#include <1886VE5.h>
#include <int17xxx.h>
unsigned char PWMCnt, b;
int Sum;
/****************************************************/
#pragma origin 0x08
interrupt iServer (void)
{  
     multi_interrupt_entry_and_save
PERIPHERAL_service:
TMR0_service:                        
     T1IF = 0;
     PW1DCH = PW1DCH + 0x10;
     if (PW1DCH == 0)
        if (--PWMCnt == 0)
           TCON2 = 0;
T0CKI_service:
INT_service:
interrupt_exit_and_restore      
}    
/****************************************************/
void Beep()
{
     PW1DCH = 0;
     PWMCnt = 0;
     TCON2 = 0x11;
}

void Init_USART(char BRG, char SYNC, char TXEN, char CREN, char SREN, char CSRC, char RX9, char TX9)
{
RCSTA = 0;
SPBRG = BRG;
//TXSTA = ((CSRC & 0x01) << 7) | ((TX9 & 0x01) << 6) |((TXEN & 0x01) << 5) |((SYNC & 0x01) << 4);
TXSTA = (CSRC & 0x01) << 7;
WREG = (TX9 & 0x01) << 6;
TXSTA |= WREG;
WREG = (TXEN & 0x01) << 5;
TXSTA |= WREG;
WREG = (SYNC & 0x01) << 4;
TXSTA |= WREG;

//RCSTA = ((RX9 & 0x01) << 6)  | ((SREN & 0x01) << 5) |((CREN & 0x01) << 4);
RCSTA = (RX9 & 0x01) << 6;
WREG = (SREN & 0x01) << 5;
RCSTA |= WREG;
WREG = (CREN & 0x01) << 4;
RCSTA |= WREG;
RCSTA = (RCSTA1 & 0x7F) | 0x80;
}
/****************************************************/
/****************************************************/
void main()
{/*
;         :
; PA0 (.) INH_MK
; PA1 (.)      32..8
; PA2 (.)     USART
; PA3 ()     USART
; PA4  
; PA5 () NSLP_LIN

; PC0 ( )  
; PC1      
 
; PC2-7 (.)  0-5

; PD0,1 (.)  6,7
; PD2 (.)  1
; PD3 (.)  SW3
; PD4-7 (.) Led0-3

; PE0-3 (.) Led4-7
*/
  GLINTD = 1;
  PORTA = 0b00111000; // NSLP = 1
  DDRA = 0b001111;
  DDRC = 0b11111101; // all input, AD1 output
  PORTD = 0;
  DDRD = 0b00001011;
  DDRE = 0; // output
  PORTE = 0; // Led4-7 off

  ADCON1 = 0b00101100; // set analog input
  ADCON0 = 0b00000000; // ADC off, AD0
//  ADIF = 0; // clear ADC interrupt flag

// init LIN  
// Init_USART(char BRG, char SYNC, char TXEN, char CREN, char SREN, char CSRC, char RX9, char TX9);
  Init_USART(  25,    0,         1,          1,          0,         0,         0,        0);
// baudrate 19200
//  T0STA = 0b00100100; // Timer0 1:4, 15Hz
// init PWM
  PR1 = 0xFF;
  PW1DCL = 0x00;
  PIR1 = 0x00;
  PIE1 = 0x10;
  INTSTA = 0x08;
  TCON1 = 0x00;
  TCON2 = 0x00;
  GLINTD = 0; // enable interrupt
  LIN_CNTR = 1; // LIN Frame Detector enable, set LINEN
    
  while(1)
  {
          while (!BRK){}
          BRK = 0; // reset bit RCIF; BRK not reset!
          
          while (!SYNCH){}
          SYNCH = 0; // reset bit RCIF; SYNCH not reset!
          
          SPBRG = LIN_BRG; // New Baudrate
          while (!RCIF){} // wait ID
          b = RCREG; // b = 0xD8 if ID = 0x18
          if (b == 0xD8)
          {
            while (!RCIF){} // wait Led status
            b = RCREG;
            PORTD = (b << 4) & 0xF0;
            PORTE = (b >> 4) & 0x0F;

            while (!RCIF){}
            if (RCREG == 0)
               Beep();
             
            while (!RCIF){} // wait Sum
            WREG = RCREG;
          }
          else
          {
 //           Sum = (PORTC >> 2) | ((PORTD & 0x03) << 6);
            Sum = PORTC >> 2;
            WREG = (PORTD & 0x03) << 6;
            Sum |= WREG;
            
            TXREG = Sum;
            while (!RCIF){}
            WREG = RCREG;            
     
            b = (PORTD & 0x08) << 4;
            TXREG = b;
            while (!RCIF){}
            WREG = RCREG;
     
            Sum = Sum + b;
            if (Sum > 0xFF)
               Sum++;  // carry add to Sum
            TXREG = ~Sum;
            while (!RCIF){}
            WREG = RCREG;            
          }
          LIN_CNTR = 0; // reset LIN Frame Detector
          LIN_CNTR = 1; // LIN Frame Detector enable, set LINEN
  } 
}
