/*
     18865.
 : 7.
*/
#include <int17xxx.h>
#include <1886VE5.h>

unsigned char PWMCnt, cmd, inp[12], i;
uns32 ID, N;          //32 bits unsigned
/****************************************************/

#pragma origin 0x08
interrupt iServer (void)
{  
     multi_interrupt_entry_and_save
PERIPHERAL_service:
TMR0_service:                        
     T1IF = 0;
     PW1DCH = PW1DCH + 0x10;
     if (PW1DCH == 0)
        if (--PWMCnt == 0)
           TCON2 = 0; // stop
T0CKI_service:
INT_service:
interrupt_exit_and_restore      
}
#include <can.c>
/****************************************************/
void Beep()
{
     PW1DCH = 0;
     PWMCnt = 0;
     TCON2 = 0x11; // start interrupt
}

/****************************************************/
char GetCmd()
{
   if (RCIF) // USART:  
   {
      if (cmd == 0)
      {
        cmd = RCREG;
        if (cmd == 01) // reset
          return 1;
        if (cmd == 03) // beep
        {
          Beep();
          cmd = 0; // done
        }
        else
        {
          if (cmd > 4) // ignore
            cmd = 0;
        }
      return 0;
      }
      else
      {
        if (cmd == 2) // set Leds
        {
          cmd = RCREG;
          PORTD = (cmd << 4) & 0xF0;
          PORTE = (cmd >> 4) & 0x0F;
          cmd = 0; // done
        }
        else
        {
          if (cmd == 4)
          {
            inp[i++] = RCREG;
            if (i > 11)
            {
              i = 0;
              cmd = 0; // done
//------------------------------------------------------------------------------------------------------------
              ID = 0;    
              ID = inp[0];
              ID = ID<<8;
              ID |= inp[1]; // ID = ID | inp[1];
              ID = ID<<8;
              ID |= inp[2];
              ID = ID<<8;
              ID |= inp[3];
//------------------------------------------------------------------------------------------------------------
              Send_Frame(0, ID, 8, 1, 0, 0, 0, 1, inp[4],inp[5],inp[6],inp[7],inp[8],inp[9],inp[10],inp[11]);
	          CAN_BSR = 0;
	          CAN_RXCS = 0;
	          CAN_CS = 3;
            }
          }
        }
      return 0;
      }
   }
   else
     return 0;
}

void CANRead()
{
  char T_N2;   
  if (RXFULL)
  {
	if ( ((CAN_ID1 & 0x08) >> 3) == 1)   //  EID_EN = 1, 
	{
//    N  .
	N=0;
    N = CAN_ID0;            //---0_0000 0000_0000 0000_0000 xxxx_xxxx
    N = N << 3;             //---0_0000 0000_0000 0000_0xxx xxxx_x000
    T_N2 = CAN_ID1 & 0xE0;  // xxx0_0000
    T_N2 = T_N2 >>5;        // 0000_0xxx 
    N |= T_N2;              //---0_0000 0000_0000 0000_0xxx xxxx_xxxx
    N = N << 2;             //---0_0000 0000_0000 000x_xxxx xxxx_xx00
    T_N2 = CAN_ID1 & 0x03;  // 0000_00xx
    N |= T_N2;              //---0_0000 0000_0000 000x_xxxx xxxx_xxxx
    N = N << 8;             //---0_0000 000x_xxxx xxxx_xxxx 0000_0000
    N |= CAN_ID2;           //---0_0000 000x_xxxx xxxx_xxxx xxxx_xxxx
    N = N << 8;             //---x_xxxx xxxx_xxxx xxxx_xxxx 0000_0000
    N |= CAN_ID3;           //---x_xxxx xxxx_xxxx xxxx_xxxx xxxx_xxxx
    }
	else
	{
//	N =  ((uns32)CAN_ID0 << 3) | ((uns32)CAN_ID1 >> 5);
	    N = 0;
        N = CAN_ID0;
        N = N << 3;
        T_N2 = CAN_ID1 & 0xE0;
        T_N2 = T_N2 >> 5;
        N |= T_N2;
    }
    
      TXREG = 0x20;
      while (!TXIF) GetCmd();

      TXREG = N >> 24;
      while (!TXIF) GetCmd();

      TXREG = N >> 16;
      while (!TXIF) GetCmd();
      
      TXREG = N >> 8;
      while (!TXIF) GetCmd();
      
      TXREG = N;
      while (!TXIF) GetCmd();
      
      //      TXREG = CAN_DB0;      
      WREG = CAN_DB0;
      TXREG = WREG;
      while (!TXIF) GetCmd();                         
      //      TXREG = CAN_DB1;
      WREG = CAN_DB1;
      TXREG = WREG;
      while (!TXIF) GetCmd();     
      //      TXREG = CAN_DB2;
      WREG = CAN_DB2;
      TXREG = WREG;  
      while (!TXIF) GetCmd();     
      //      TXREG = CAN_DB3;
      WREG = CAN_DB3;
      TXREG = WREG;  
      while (!TXIF) GetCmd();       
      //      TXREG = CAN_DB4;
      WREG = CAN_DB4;
      TXREG = WREG;  
      while (!TXIF) GetCmd();    
      //      TXREG = CAN_DB5;
      WREG = CAN_DB5;
      TXREG = WREG;  
      while (!TXIF) GetCmd();     
      //      TXREG = CAN_DB6;
      WREG = CAN_DB6;
      TXREG = WREG;  
      while (!TXIF) GetCmd();     
      //      TXREG = CAN_DB7;
      WREG = CAN_DB7;
      TXREG = WREG;  
       while (!TXIF) GetCmd();
                    
	CAN_BSR = 0;
	CAN_RXCS = 0;
	CAN_TXCS = 0;
	CAN_CS = 3;
  }
}
/****************************************************/
void main()
{/*
;         :
; PA0 (.) INH_MK
; PA1 (.)      32..8
; PA2 (.)     USART
; PA3 ()     USART
; PA4  
; PA5 () NSLP_LIN

; PC0 ( )  
; PC1   
 
; PC2-7 (.)  0-5

; PD0,1 (.)  6,7
; PD2 (.)  1
; PD3 (.)  SW3
; PD4-7 (.) Led0-3

; PE0-3 (.) Led4-7
*/
char TEMP_BUF=0;
Restart:
  GLINTD = 1;
  PORTA = 0;
  DDRA = 0b000111;
  DDRC = 0b11111111; // all input
  PORTD = 0;
  DDRD = 0b00001011;
  DDRE = 0; // output
  PORTE = 0; // Led4-7 off 

  ADCON1 = 0b01101100; // set analog input Fc/32
  ADCON0 = 0b00000101; // ADC on, AD0
  ADCIF = 0; // clear ADC interrupt flag
// Init_USART(char BRG, char SYNC, char TXEN, char CREN, char SREN, char CSRC, char RX9, char TX9);
  Init_USART(  0x0c,    0,         1,          1,          1,         0,         0,        0);
// baudrate 38400
  T0STA = 0b00100100; // Timer0 1:4, 15Hz
  cmd = 0;
  i = 0;
// init PWM
  PR1 = 0xFF;
  PW1DCL = 0x00;
  PIR1 = 0x00;
  PIE1 = 0x10;
  INTSTA = 0x08;
  TCON1 = 0x00;
  TCON2 = 0x00;
  GLINTD = 0;
// init CAN  
  CAN_CNTR = 0x01;
  SetSpeed (0,0,2,2,0,0); // 500 kb/s
	CAN_BSR = 0;
	CAN_RXCS = 0;
	CAN_CS = 3;
    
  while(1){ // main loop
    if (GetCmd()) goto Restart; // return 1 if restart
    CANRead();

    if (T0IF) // Timer0 Interrupt Flag
    {
      T0IF = 0; // clear Timer0 Interrupt flag
      TXREG = 0x10;
      while (!TXIF)
      {
        if (GetCmd()) goto Restart;
        if ((FERR == 1) || (OERR == 1))
        {
          WREG=RCREG; //   
          CREN = 0; //   
          CREN = 1;
        }
      }
//-----------------------------
      TEMP_BUF = PORTC>>2;                     //
      TXREG = TEMP_BUF | ((PORTD & 0x03)<<6);  // send Jumper status
//-----------------------------        
      while (!TXIF)
        if (GetCmd()) goto Restart;
      TXREG = ADRESH | ((PORTD & 0x08) << 4); // send Button and high bits of ADC
      while (!TXIF)
        if (GetCmd()) goto Restart;
      WREG = ADRESL;  
      TXREG = WREG;
      while (!TXIF)
        if (GetCmd()) goto Restart;
      ADCIF = 0; // clear ADC interrupt flag
      GO_DONE = 1; // Start ADC
    }
  }
}
