/*; *******************************************************************************
;         :
; RA0 (.)     GND
; RA1 (.)   8 ( )
; RA2,3 (.=0)  
; RA4 (./.)   ( )
; RA5 (.)  ( )
; RB0,1 (.=0)  
; RB2 (.)  1
; RB3 (.)  2
; RB4,5,6,7 (.=0)  
; RC0-RC7 (.)  () LED 
; RD0-RD7 (.)  () LED 
; RE0-RE3 (.)  4 
; RF0-RF7 (.)   
; RG0 (.=0)  
; RG1 ( )  
; RG2,3,4,5 (.=0)  
; RG6 ()     USART2
; RG7 ()     USART2
; ********************************************************************************/


#include <1886VE2.h>
#include "int17xxx.h"
#pragma origin 0x8

//******************************

#pragma bit pwm1 @ PORTB.2           // 1                                               
#pragma bit pwm2 @ PORTB.3           // 2                                     
#pragma char symbol @ PORTC          //   8-  
#pragma char rank @ PORTD            //   8-  
#pragma char keypad @ PORTE          //  
#pragma char leds @ PORTF            // 
#pragma bit ruart @ PORTG.6          //                               
#pragma bit tuart @ PORTG.7          //   


char TBLPTRL1;                       //  
char TBLPTRH1;                       //                           
bit stml;                            //          
char del3;                           //      
char adcr[2];                         //  - - 
bit txadc;                           //  1 -   -   
char rc;                             //  
bit indcomp;                         //    
bit comp;                            //    
bit c;                               //  tabl
char ptrf;                           // sin
char tL;                             // sin 
char tH;
char dtL;                            // 
char dtH;
char fn1;                            //                 
char fn;                             //                                
bit chose;                           //  (0-,1-)
char leds1;                          //  
char hr;                             //
char min;                            //
char sec;                            //
uns16 del640;                        //   640( )
char  del64;                         //  ADC
char tabl[8];                        //     8-  
char rs[8];                          //  
char i;                              //  
char klav,klavpr,klav1,sovp;         // - (),  -,   -, - 
bit kl,dr;                           //  - -     , 
                                     //  -  -       -
//******************************
void normtime();                     //  
void tablgen();                      //   8-  

//******************************

const char zngen[17]={63,6,91,79,102,109,125,7,127,111,119,124,57,94,121,113,64};                                                                               //     

const char dth[]={0x0A,0x9,0x7,0x8,0x9,0x7,0x8,0x9,0x8,0x7,0x7,0x0A,0x0A,0x0A,0x9,0x8,0x7,0x8,0x9,0x7,0x8,0x9,0x8,                                              //  
           0x7,0x7,0x0A,0x9,0x7,0x8,0x9,0x7,0x8,0x9,0x8,0x7,0x7,0x0A,0x0A,0x0A,0x9,0x8,0x7,0x8,0x9,0x7,0x8,                                                     //                    
           0x9,0x8,0x7,0x7,0x0A,0x9,0x7,0x8,0x9,0x7,0x8,0x9,0x8,0x7,0x7,0x0A,0x0A,0x0A,0x9,0x8,0x7,0x8,0x9,                                                     //                                  
           0x7,0x8,0x9,0x8,0x7,0x7,0};
                        
                        
const char dtl[]={0x7E,0x59,0xDD,0x54,0x59,0xDD,0x54,0x59,0x54,0xDD,0x01,0x7E,0x32,0x7E,0x59,0x54,0xDD,0x54,0x59,                                               // 
          0xDD,0x54,0x59,0x54,0xDD,0x01,0x7E,0x59,0xDD,0x54,0x59,0xDD,0x54,0x59,0x54,0xDD,0x01,0x7E,0x32,                                                       //         
          0x7E,0x59,0x54,0xDD,0x54,0x59,0xDD,0x54,0x59,0x54,0xDD,0x01,0x7E,0x59,0xDD,0x54,0x59,0xDD,0x54,                                                       //                   
          0x59,0x54,0xDD,0x01,0x7E,0x32,0x7E,0x59,0x54,0xDD,0x54,0x59,0xDD,0x54,0x59,0x54,0xDD,0x01,0};                                                         //                          
                       
const char dlit[]={0x30,0x30,0x18,0x18,0x30,0x18,0x18,0x30,0x18,0x18,0x30,0x18,0x1,0x18,0x24,0x0C,0x18,0x18,0x30,                                               //  
           0x18,0x18,0x30,0x18,0x18,0x30,0x28,0x28,0x14,0x14,0x28,0x14,0x14,0x28,0x14,0x14,0x28,0x14,0x1,                                                       //        
           0x14,0x1E,0x0A,0x14,0x14,0x28,0x14,0x14,0x28,0x14,0x14,0x28,0x20,0x20,0x10,0x10,0x20,0x10,0x10,                                                      //                
           0x20,0x10,0x10,0x20,0x1,0x1,0x10,0x18,0x8,0x10,0x10,0x20,0x10,0x10,0x20,0x10,0x10,0x20,0xF0}; 

const char sin128[]={64,67,70,73,76,79,82,85,88,91,94,96,99,102,104,106,109,111,113,115,116,118,120,121,122,123,124,125,126,126,127,127,127,127,                //
           127,126,126,125,124,123,122,121,120,118,116,115,113,111,109,106,104,102,99,96,94,91,88,85,82,79,76,73,70,67,64,61,58,55,52,                          //         
           49,46,43,40,37,34,32,29,26,24,22,19,17,15,13,12,10,8,7,6,5,4,3,2,2,1,1,1,1,1,2,2,3,4,5,6,7,8,10,12,13,15,17,19,22,24,26,29,                          //                 
           32,34,37,40,43,46,49,52,55,58,61};

//******************************
interrupt iServer(void)
{   
    multi_interrupt_entry_and_save
    
    PERIPHERAL_service:
    char FSR01=FSR0;                 //  . 
    if (TMR1IF)                      //    1(  ~24,1 )
    {
       TMR1IF=0;                             
       if(PWM2ON)                    //2   sin
       {
         fn1--;                      //
         if(fn1==0)                  //      
         {                           //                  
          fn--;                      //                       
          if(fn==0)                  //
          {
            if(ptrf>=77) {ptrf=0;}  // 
            ptrf++;                 //                
            tL=0;
            tH=0;
            dtL=dtl[ptrf-1];        //   . 
            dtH=dth[ptrf-1];        //   . 
            fn=dlit[ptrf-1];        //      
          }          
         }
         tL+=dtL;                   // 
         tH+=dtH+ALUSTA.0;          //               
         PW2DCH=sin128[(tH>>1)&0x7F];        //  
       }
       if(PWM1ON)
       {
          del3--;                                 // 
          if(del3==0)                             //          3(~8 )
          {
            TBLPTRL=TBLPTRL1;                                      
            TBLPTRH=TBLPTRH1;                                      
            del3=3;
            char temp;                            // 
            if(stml)                              //           
              temp=readL();                       //                 
            else                                  //                      
              temp=readHUInc();                   //                         
            stml=!stml;
            PW1DCL.7=temp.1;                      //              
            temp=temp>>1;                         //        
            PW1DCH=temp&0x7F;                     //              1
            TBLPTRL1=TBLPTRL;                                      
            TBLPTRH1=TBLPTRH;
            if((TBLPTRH==0xBF)&&(TBLPTRL>=0xA0))  //    
               PWM1ON=0;                          // 1
          }          
       }           
    }
  
    if (TMR3IF)                      //    3(  640 )
    {
       TMR3IF = 0;                   //   
       if(i==8){i=0;}                //
       rank=rs[i];                   //i- 
       symbol=tabl[i];               //
       i++;                          //
       if(del64==0)
       {
         del64=64;                    //    10  
         ADCON0.2=1;
         normtime();                  //  
         tablgen();                   //   8-              
       }
       else{del64--;}
       if(del640==0)                 //     
       {                             
         del640=640;          
         sec++;        
         bit led;
         led=leds1.7;              
         leds1=leds1<<1;
         leds1.0=led;              
         leds=leds1;    
       }
       else{del640--;}        
//*****************************       
       klav1=(keypad^255)&15;        
       if(sovp==20)                  // -  20 
       {
          klav=klav1;                // - 
          kl=1;                      //-   
          sovp=0;                    //  
       }
       else                          //
       {
          klav=0;                    //-  
          if(klav1==klavpr)          //    -  
             sovp++;                 //    
          else                       //   
          {
             klavpr=klav1;           //  - 
             dr=1;                   //-   -
             kl=0;                   //  
             sovp=0;                 // 
          }   
       }          
//*****************************             
    }
    FSR0=FSR01;                      // cc   
    goto RESTORE_and_return;
 TMR0_service:
    // save on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
    /* process Timer 0 interrupt */
    // T0IF is automatically cleared when the CPU vectors to 0x10
    // restore on demand: PRODL,PRODH,TBLPTRH,TBLPTRL,FSR0,FSR1
 T0CKI_service:
 INT_service:
             
 RESTORE_and_return:
           
   interrupt_exit_and_restore
}
/*******************************/

/*******************************/
void main(void)
{
     GLINTD=1;                               //   .      
     PR3L=106;                               // 
     PR3H=24;                                //             3.
     PR1=166;                                //     1.
     TCON1=0;                                //
     TCON2=5;                                //
     TCON3=0;                                //
     DDRC=0;                                 //PORTC - 
     DDRD=0;                                 //PORTD -  
     DDRF=0;                                 //PORTF - 
     DDRG=0b01001110;                        //PORTG1,2,3,6-
     ADCON1=0b10101010;                      // ADC FC/64, , PORTG1,2,3 -  ,   Avdd, Avss 
     ADCON0=0b00100001;                      //AN2 -  ,  ADC 
     SPBRG2=25;                              // / 9600 /
     TXSTA2=0;                               //
     TXEN2=1;                                // 
     RCSTA2=0b10110000;                      //. USART2, 8  ,    
     leds1=leds=254;
     DDRE=15;                                //DDRE.<0-3> - 
     hr=min=sec=0;                           // 
     INTSTA=8;                               //  
     PIE1=0b01010000;                        //   1, 3
     PIE2=0b00000000;                        //    
     keypad=0;                               
     sovp=0;                                 //                                   
     del640=640;                             // 
     del64=64;                               //  64  ADC
     rs[0]=8;                                // 
     rs[1]=4;                                //          
     rs[2]=2;                                //              
     rs[3]=1;                                //                     
     rs[4]=16;                               //                             
     rs[5]=32;                               //
     rs[6]=64;                               //
     rs[7]=128;                              //
     klav=klav1=klavpr=0;                    // 
     i=0;                                    //   
     kl=0;                                   // 
     dr=0;                                   //             
     chose=0;                                //    /                                
     rc=0;                                   //  
     indcomp=0;                              //     -
     comp=0;                                 //      
     c=0;                                    //    LED
     txadc=0;                                //    
     adcr[0]=0;                              //    
     adcr[1]=0;                              //                            
     GLINTD=0;                               //   
     while(1)
     {             
        if(ADIF)                             //     COM
        {
           ADON=0;                           // 
           adcr[0]=ADRESH;                   // - 
           adcr[1]=ADRESL;                   //                    
           if(TX2IF)                         
           {                      
             if(!txadc)                      //       
             {
               TXREG2=adcr[0];               
               ADIF=1;                       
               txadc=1;
             }
             else                            //     
             {
               TXREG2=adcr[1];                                     
               txadc=0;
               ADIF=0;
               ADON=1;                       //                       
             }
           }           
        }      
        if(RC2IF)                            //    COM
        {
           rc=RCREG2;
           indcomp=1;
           comp=1;
        }           
        if(kl && dr && (klav!=0))            // 
        {
            indcomp=0;   
            if((klav==0b1001)&&(!chose))     // 
            {
               min++;
               if(min>89)
                  min=0;
               sec=0;             
            }
            else if((klav==0b1010)&&(!chose)) //             
            {
               hr++;
               sec=0;   
            }
            else if(klav==0b0100)             //  /
            {
              chose=!chose;   
            }
            else if(klav==0b0010)             // sin 
            {
              if(!PWM2ON)
              {
                 fn=1;
                 fn1=1;
                 ptrf=0;
                 dtL=dtH=0;
                 tL=tH=0;
                 PW2DCL=0;
                 PW2DCH=0x40;     
              }
              PWM2ON=!PWM2ON;                    
            }
            else if(klav==0b0001)                // 
            {
               if(!PWM1ON)
               {
                 TBLPTRL1=0x00;                   // 
                 TBLPTRH1=0x08;                   //               
                 char temp;
                 temp=readHUInc();
                 PW1DCL=0;                       //  1
                 PW1DCH=0x40;                    //
                 del3=3;
                 stml=1;         
               }
               PWM1ON=!PWM1ON;                
            }
            kl=0;
            dr=0;
        }                               
     }          
}

void tablgen()                          
{
  if(indcomp)
  {
    char j;       
    if(c==0)                                     //  LED
      {  
         for(j=0;j<8;j++)                        
            tabl[j]=0;
         for(j=0;j<8;j++)
            tabl[j]=0;   
         c=1;   
      }
    if(comp)                                     //     
    {  
      for(j=7;j>1;j--)
      { 
        char temp;              
        temp=tabl[j-2];
        tabl[j]=temp;
      }
      tabl[0]=zngen[rc&15];
      tabl[1]=zngen[(rc&240)>>4];
      comp=0;
    }       
  }   
  else 
  {
    if(chose)                                    // - - 
    {
       c=0;    
       tabl[7]=119;                          // 
       tabl[6]=94;                           //   "AdC="   
       tabl[5]=57;                           //
       tabl[4]=72;                           //
       tabl[3]=63;
       tabl[2]=zngen[(adcr[0])&15];
       tabl[1]=zngen[((adcr[1])&240)>>4];
       tabl[0]=zngen[(adcr[1])&15];
    }
    else                                     //  
    { 
       c=0;
       tabl[0]=zngen[sec&15];
       tabl[1]=zngen[(sec&240)>>4];
       tabl[2]=zngen[16];
       tabl[3]=zngen[min&15];
       tabl[4]=zngen[(min&240)>>4];
       tabl[5]=zngen[16];
       tabl[6]=zngen[hr&15];
       tabl[7]=zngen[(hr&240)>>4];
    }
  }
  return;
}


void normtime()
{
   sec=decadj(sec);
   if(sec>=96)
   {
     sec=0;
     min++;
   }
   min=decadj(min);
   if(min>=96)
   {
     min=0;
     hr++;
   }
   hr=decadj(hr); 
   if(hr>=36)
     hr=0;        
   return;                       
}

