; *******************************************************************************
;         :
; RA0 (.)     GND
; RA1 (.)   8 ( )
; RA2,3 (.=0)  
; RA4 (./.)   ( )
; RA5 (.)  ( )
; RB0,1 (.=0)  
; RB2 (.)  1
; RB3 (.)  2
; RB4,5,6,7 (.=0)  
; RC0-RC7 (.)  () LED 
; RD0-RD7 (.)  () LED 
; RE0-RE3 (.)  4 
; RF0-RF7 (.)   
; RG0 (.=0)  
; RG1 ( )  
; RG2,3,4,5 (.=0)  
; RG6 ()     USART2
; RG7 ()     USART2
; *******************************************************************************
; 22/05/2007   MPLAB
        Include 1886ve2m.INC

		radix dec

; ------ RCSTA2 bits ------
#DEFINE	OERR2	RCSTA2,1
#DEFINE	CREN2   RCSTA2,4
; ------ TXSTA2 bits ------
#DEFINE	TXEN2	TXSTA2,5
; -------------------------
PCLAT_1 EQU     01EH    ;    PCLATH    TMR1
BSR_1   EQU     01FH    ;    BSR    TMR1
;
ALUST_1 EQU     020H    ;    ALUSTA    TMR1
WREG_1  EQU     021H    ;    WREG    TMR1
DFL     EQU     024H    ; .     
DFH     EQU     025H    ; .     
KFL     EQU     026H    ; .     
KFH     EQU     027H    ; .     
FNL     EQU     028H    ; .    
FNH     EQU     029H    ; .    
UkazF   EQU     02AH    ;   
WORK_1  EQU     02BH    ;   (     TMR1)
DEL3_1  EQU     02CH    ;      TMR1  3 ( ~ 8)
; 040H-047H -   LED .
RAZR    EQU     048H    ;     
SEC     EQU     049H    ;   ( - )
MIN     EQU     04AH    ;  
CHAS    EQU     04BH    ;  
DEL125  EQU     04CH    ; -  125
DEL4    EQU     04DH    ; -  4
LEDLine EQU     04EH    ;     (=0 -  )
KLAV3   EQU     04FH    ;      
KLAV2   EQU     050H    ; ""  
KLAV1   EQU     051H    ; ""  
KLAV    EQU     052H    ; ""     
ALUST_3 EQU     053H    ;    ALUSTA    TMR3
WREG_3  EQU     054H    ;    WREG    TMR3
PCLAT_3 EQU     055H    ;    PCLATH    TMR3
FSR1_3  EQU     056H    ;    FSR1    TMR3
BSR_3   EQU     057H    ;    BSR    TMR3
PAUSE   EQU     058H    ;   (8 )     
                        ; . PAUSE,5=0-   ; =1-/.
FLAG    EQU     059H    ;  :
                ; FLAG,0-   "" ( )
                ; FLAG,1-  (0) /     (1)
WORK_3  EQU     05AH    ;   (     TMR3)

WORK    EQU     060H    ;    
DL_ADC  EQU     061H    ;       
DH_ADC  EQU     062H    ;       
; ************************************************************************************
;;;;;           CODE
                ORG     0000H

Start:  BSF     CPUSTA,GLINTD	;   
        CLRF    BSR,F   ;  SFR  GPR Bank 0
        GOTO    Start0

; ************************************************************************************
;     (    TMR1  TMR3)
; ************************************************************************************
                ORG     0020H
INT1:   MOVFP   BSR,BSR_1       ;   BSR
        CLRF    BSR,F           ;  SFR  GPR Bank 0
        MOVLB   01H             ;  SFR Bank 1
        MOVFP   PCLATH,PCLAT_1  ;   PCLATH

        BTFSS   PIR1,TMR1IF	;     TMR1
        GOTO    INT3            ;     TMR1,       TMR3

        NOP             ; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;    TMR1 (  ~24.096 ).

        MOVPF   ALUSTA,ALUST_1  ;  
        MOVPF   WREG,WREG_1

        BCF     PIR1,TMR1IF	;      TMR1

        MOVLB   03H                     ;  SFR Bank 3

        BTFSS   TCON2,PWM2ON	;   2 ( . )
        GOTO    INT120          ;  - 2 

        DECFSZ  FNL,F   ;    
        GOTO    INT110
        DECFSZ  FNH,F
        GOTO    INT110

        MOVLW   (TblDFH-TblDFL-1)       ;    
        CPFSLT  UkazF           ;    
        CLRF    UkazF,F         ;  
        INCF    UkazF,F         ;    

        DECF    UkazF,W
        CALL    TblDFL          ;   .  
        MOVWF   DFL
        DECF    UkazF,W
        CALL    TblDFH          ;   .  
        MOVWF   DFH
        DECF    UkazF,W
        CALL    TblFNH          ;   .  
        MOVWF   FNH             ; (  ~10.6 )

INT110: MOVFP   DFL,WREG
        ADDWF   KFL,F
        MOVFP   DFH,WREG
        ADDWFC  KFH,F
        RRNCF   KFH,W
        ANDLW   7FH
        CALL    FSIN
        MOVWF   PW2DCH

INT120: INCF    DEL3_1,F        ;     3, ..  ~8 
        BTFSC   TCON2,PWM1ON	;    1 ( )
        BTFSS   DEL3_1,1        ;    3, ..  ~8 
        GOTO    INT140

        INCF    DEL3_1,F        ;    

        TLRD    0,WORK_1        ;  .   
        BTFSC   DEL3_1,2        ;  / 
        TABLRD  1,1,WORK_1      ;  .   ,  
                        ;         
        RRNCF   WORK_1,W
        ANDLW   7FH
        MOVWF   PW1DCH
        RRNCF   WORK_1,W
        ANDLW   80H
        MOVWF   PW1DCL

        MOVLW   high(EndTBL+1)  ;     
        CPFSEQ  TBLPTRH
        GOTO    INT140
        MOVLW   low(EndTBL+1)
        CPFSLT  TBLPTRL
        BCF     TCON2,PWM1ON	;  1

INT140: MOVFP   PCLAT_1,PCLATH  ;  
        MOVFP   WREG_1,WREG
        MOVFP   ALUST_1,ALUSTA
        MOVFP   BSR_1,BSR
        RETFIE
; *************************************************************************************
;        
;   0-9, A, B, C, D, E, F       
; *************************************************************************************
ZNGen:  ANDLW   0FH
        ADDWF   PCL,F
        RETLW   03FH    ; "0"
        RETLW   006H    ; "1"
        RETLW   05BH    ; "2"
        RETLW   04FH    ; "3"
        RETLW   066H    ; "4"
        RETLW   06DH    ; "5"
        RETLW   07DH    ; "6"
        RETLW   007H    ; "7"
        RETLW   07FH    ; "8"
        RETLW   06FH    ; "9"
        RETLW   077H    ; "A"
        RETLW   07CH    ; "b"
        RETLW   039H    ; "C"
        RETLW   05EH    ; "d"
        RETLW   079H    ; "E"
        RETLW   071H    ; "F"
; *************************************************************************************
;        ()  SIN    .
;       ( 128 )
; *************************************************************************************
FSIN:   ADDWF   PCL,F
        RETLW   64
        RETLW   67
        RETLW   70
        RETLW   73
        RETLW   76
        RETLW   79
        RETLW   82
        RETLW   85
        RETLW   88
        RETLW   91
        RETLW   94
        RETLW   96
        RETLW   99
        RETLW   102
        RETLW   104
        RETLW   106
        RETLW   109
        RETLW   111
        RETLW   113
        RETLW   115
        RETLW   116
        RETLW   118
        RETLW   120
        RETLW   121
        RETLW   122
        RETLW   123
        RETLW   124
        RETLW   125
        RETLW   126
        RETLW   126
        RETLW   127
        RETLW   127
        RETLW   127
        RETLW   127
        RETLW   127
        RETLW   126
        RETLW   126
        RETLW   125
        RETLW   124
        RETLW   123
        RETLW   122
        RETLW   121
        RETLW   120
        RETLW   118
        RETLW   116
        RETLW   115
        RETLW   113
        RETLW   111
        RETLW   109
        RETLW   106
        RETLW   104
        RETLW   102
        RETLW   99
        RETLW   96
        RETLW   94
        RETLW   91
        RETLW   88
        RETLW   85
        RETLW   82
        RETLW   79
        RETLW   76
        RETLW   73
        RETLW   70
        RETLW   67
        RETLW   64
        RETLW   61
        RETLW   58
        RETLW   55
        RETLW   52
        RETLW   49
        RETLW   46
        RETLW   43
        RETLW   40
        RETLW   37
        RETLW   34
        RETLW   32
        RETLW   29
        RETLW   26
        RETLW   24
        RETLW   22
        RETLW   19
        RETLW   17
        RETLW   15
        RETLW   13
        RETLW   12
        RETLW   10
        RETLW   8
        RETLW   7
        RETLW   6
        RETLW   5
        RETLW   4
        RETLW   3
        RETLW   2
        RETLW   2
        RETLW   1
        RETLW   1
        RETLW   1
        RETLW   1
        RETLW   1
        RETLW   2
        RETLW   2
        RETLW   3
        RETLW   4
        RETLW   5
        RETLW   6
        RETLW   7
        RETLW   8
        RETLW   10
        RETLW   12
        RETLW   13
        RETLW   15
        RETLW   17
        RETLW   19
        RETLW   22
        RETLW   24
        RETLW   26
        RETLW   29
        RETLW   32
        RETLW   34
        RETLW   37
        RETLW   40
        RETLW   43
        RETLW   46
        RETLW   49
        RETLW   52
        RETLW   55
        RETLW   58
        RETLW   61
; *************************************************************************************
;           
;       TblDFH/TblDFL - ./.     
;       TblFNH - .     ( ~10.6)
; *************************************************************************************
                ORG     0100H
TblDFL: ADDWF   PCL,F
        include df_low.asm
TblDFH: ADDWF   PCL,F
        include df_hight.asm
TblFNH: ADDWF   PCL,F
        include dlit.asm
; *************************************************************************************
;            
; *************************************************************************************
                ORG     0200H
ARazr:  ADDWF   PCL,F
        RETLW   80H     ;  1 
        RETLW   40H     ;  2 
        RETLW   20H     ;  3 
        RETLW   10H     ;  4 
        RETLW   01H     ;  5 
        RETLW   02H     ;  6 
        RETLW   04H     ;  7 
        RETLW   08H     ;  8 
; *************************************************************************************
;    TMR3 (  500 ).
; *************************************************************************************
INT3:   MOVPF   ALUSTA,ALUST_3  ;  
        MOVPF   WREG,WREG_3
        MOVPF   BSR_1,BSR_3
        MOVPF   PCLAT_1,PCLAT_3
        MOVPF   FSR1,FSR1_3

        BCF     PIR1,TMR3IF	;      TMR3
        BCF     PIE1,TMR3IE	;    TMR3
        BCF     CPUSTA,GLINTD	;    

;      (RAZR-   0...7).
        MOVLW   07H
        ANDWF   RAZR,W
        MOVWF   FSR1
        CALL    ARazr           ;     
        CLRF    PORTC,F         ;    (SFR Bank 1)
        MOVFP   WREG,PORTD      ;    
        BSF     FSR1,6          ; FSR-     
        INCF    RAZR,F          ;    
        MOVFP   INDF1,PORTC     ;    ( )

;        (  "" ).
        COMF    PORTE,W ;     
        ANDLW   0FH             ;    ( )
        CPFSEQ  KLAV2   ;   "" 
        CLRF    KLAV3,F ;    -   
        MOVWF   KLAV2
        INCF    KLAV3,F ;   
        BTFSS   KLAV3,4 ;   
        GOTO    INT33
        DECF    KLAV3,F
        CPFSEQ  KLAV1   ;  ""   
        MOVWF   KLAV            ;   "" 
        MOVWF   KLAV1
INT33:
;      125 (..   4 ).
        DECFSZ  DEL125,F
        GOTO    INT37   ;    INT37  (DEL125)   

;    .
        MOVLB   05H                     ;  SFR Bank 5
        MOVLW   6AH             ;  Fosc/32,   ,
        MOVWF   ADCON1  ;   ,   AVdd  AVss
        MOVLW   21H
        MOVWF   ADCON0  ;      

        MOVLW   125
        MOVWF   DEL125  ;  - DEL125  .125

;  " "    (   (LEDLine)=0FEH).
        RLNCF   LEDLine,F               ;     
        MOVFP   LEDLine,PORTF   ;     

;   (8 )      .
        BTFSS   PAUSE,5
        INCF    PAUSE,F

;   ~20      .
        MOVLW   26
        MOVWF   WORK_3
INT35:  DECFSZ  WORK_3,F
        GOTO    INT35

        BSF     ADCON0,GO ; (  ADCON0,GO_DONE)   

;   4   4 (..   1  -  ).
        INCF    DEL4,F  ;  
        BTFSS   DEL4,2  ;  Bit2=1, .. (DEL4)=4
        GOTO    INT37           ;    INT37  (DEL4)   4
        CLRF    DEL4,F  ;  

;   ().
        BSF     FLAG,0  ;    ""

        INCF    SEC,W   ;  ""
        DAW     SEC,F   ;   
        MOVLW   59H
        CPFSGT  SEC             ;     (SEC)>59H
        GOTO    INT37
        CLRF    SEC,F   ;   

        INCF    MIN,W   ;  ""
        DAW     MIN,F           ;   
        MOVLW   59H
        CPFSGT  MIN             ;     (MIN)>59H
        GOTO    INT37
        CLRF    MIN,F           ;   

        INCF    CHAS,W  ;  ""
        DAW     CHAS,F  ;   
        MOVLW   24H
        CPFSLT  CHAS            ;     (CHAS)<24H
        CLRF    CHAS,F  ;   

;   -  .
INT37:  MOVFP   FSR1_3,FSR1
        MOVFP   PCLAT_3,PCLATH
        MOVFP   WREG_3,WREG
        MOVFP   ALUST_3,ALUSTA

        MOVLB   01H				;  SFR Bank 1
        BSF     CPUSTA,GLINTD	;   
        BSF     PIE1,TMR3IE		;    TMR3

        MOVFP   BSR_3,BSR		;   BSR
        RETFIE
; **************************************************************************************
; **************************************************************************************
;    /,    ..
Start0: CLRF    PORTA,F ;   PORTA

        CLRF    PORTB,F ;   PORTB
        CLRF    DDRB,F  ; PORTB - 

        CLRF    RCSTA1,F        ;  USART1
        CLRF    TXSTA1,F

        MOVLB   01H     ; *  SFR Bank 1

        CLRF    PORTC,F ;   PORTC
        CLRF    DDRC,F  ; PORTC - 
        CLRF    PORTD,F ;   PORTD
        CLRF    DDRD,F  ; PORTD - 
        SETF    DDRE,F  ; PORTE - 

        MOVLW   50H     ;  .   TMR3  TMR1
        MOVWF   PIE1    ;   PORTB, TMR2, Capture 2  1, USART1
        CLRF    PIR1,F  ;    

        MOVLB   02H     ; *  SFR Bank 2

        MOVLW   165
        MOVWF   PR1     ;     TMR1 (~24.096 )
        MOVLW   low(7999)
        MOVWF   PR3L
        MOVLW   high(7999)
        MOVWF   PR3H    ;     TMR3 (=500 )

        MOVLB   03H     ; *  SFR Bank 3

        CLRF    TCON1,F ; TMR1  TMR3 -    
        MOVLW   05H
        MOVWF   TCON2   ;  TMR1  TMR3 ( )

        MOVLB   04H     ; *  SFR Bank 4

        CLRF    PIE2,F  ;    SSP, , Capture 4  3, USART2
        CLRF    PIR2,F  ;    

        MOVLW   25
        MOVWF   SPBRG2  ;   / USART2 9600 /
        CLRF    TXSTA2,F        ;   USART2 - 
        MOVLW   90H
        MOVWF   RCSTA2  ;  USART2   
        BSF     TXEN2   ; (TXSTA2,TXEN2)  

        MOVLB   05H     ; *  SFR Bank 5

        SETF    PORTF,F ;  PORTF  ""
        CLRF    DDRF,F  ; PORTF - 
        CLRF    PORTG,F ;   PORTG
        MOVLW   42H
        MOVWF   DDRG    ; PORTG0,2,3,4,5,7 - , PORTG1,6 - 

        MOVLW   6AH     ;      
        MOVWF   ADCON1  ; .  (PORTF4,5,6 PORTG1,2,3)
        MOVLW   20H
        MOVWF   ADCON0  ;    ()

        MOVLB   06H     ; *  SFR Bank 6

        CLRF    SSPCON1,F       ;   SSP

        MOVLB   07H     ; *  SFR Bank 7

        CLRF    TCON3,F ;  3  ..

;   Bank 0 (020H-0FFH)
        SETF    ALUSTA,F        ;    "1" ( -INC/DEC FSR)
        MOVLW   020H
        MOVWF   FSR0
M020:   CLRF    INDF0,F
        INCFSZ  FSR0,F
        GOTO    M020
;  
        MOVLW   08H     ;    
        MOVWF   INTSTA  ; (   RA1/TOCKI, RA0/INT   TMR0)
;   
        MOVLW   0FEH
        MOVWF   LEDLine ;     
        BSF     PAUSE,5 ;     /  

        BCF     CPUSTA,GLINTD	;    
;
M100:   CLRWDT                  ;  " "
        MOVLW   0D0H
        MOVWF   ALUSTA  ;    FSR0 (FSR1-)

;   USART2          .
        MOVLB   04H             ;  SFR Bank 4

        BTFSS   PIR2,RC2IF	;      
        GOTO    M200		;  -   

        BTFSC   PAUSE,5 ;     
        CALL    ClrScr ;   -   /  

        MOVLW   040H            ;    
        MOVWF   FSR0
        MOVLW   041H
        MOVWF   FSR1
M122:   MOVFP   INDF1,INDF0     ;     (FSR0-)
        INCF    FSR1,F
        BTFSS   FSR1,3
        GOTO    M122

        MOVPF   RCREG2,WREG     ;   ( USART2)
        CALL    ZNGen           ;    
        MOVWF   047H            ;        
        CLRF    PAUSE,F         ; .       =8

        BTFSC   OERR2   ; (RCSTA2,OERR(1))    
        BCF     CREN2   ;   -     
        BSF     CREN2   ; (RCSTA2,CREN(4))  

;    ,    USART,   .
M200:   BTFSS   PIR2,ADIF	;      (SFR Bank 4)
        GOTO    M300

        BCF     PIR2,ADIF	;     

        MOVLB   05H                     ;  SFR Bank 5

        MOVPF   ADRESL,DL_ADC   ;         
        MOVPF   ADRESH,DH_ADC   ;         
        BCF     ADCON0,ADON	;   

        MOVLB   04H                     ;  SFR Bank 4

M210:   BTFSS   PIR2,TX2IF	;    USART2
        GOTO    M210
        MOVFP   DL_ADC,TXREG2   ;    

        BTFSC   FLAG,1  ;    /  
        BTFSS   PAUSE,5 ;       
        GOTO    M220            ;  -     

        MOVLW   077H
        MOVWF   040H                    ;     "AdC="
        MOVLW   05EH
        MOVWF   041H
        MOVLW   039H
        MOVWF   042H
        MOVLW   048H
        MOVWF   043H
        MOVFP   DH_ADC,WREG     ;       
        CALL    ZNGen           ;    (: AdC=3FFh)
        MOVWF   044H
        SWAPF   DL_ADC,W
        CALL    ZNGen
        MOVWF   045H
        MOVFP   DL_ADC,WREG
        CALL    ZNGen
        MOVWF   046H
        MOVLW   074H
        MOVWF   047H                    ;     "h"

M220:   BTFSS   PIR2,TX2IF	;    USART2
        GOTO    M220
        MOVFP   DH_ADC,TXREG2   ;    

;                      .
;   :
; 1010b -  () "" +  ""
; 1001b -  () "" +  ""
; 0100b -  :  /   
; 0010b - /   
; 0001b - /   

M300:   MOVFP   KLAV,WREG       ;      
        MOVPF   WREG,WORK
        BTFSC   ALUSTA,Z	;     
        GOTO    M400            ;  -   

        CLRF    KLAV,F          ;    

        MOVLW   0AH
        CPFSEQ  WORK    ;      ""
        GOTO    M310    ;  -   
        INCF    CHAS,W  ;  ""
        DAW     CHAS,F  ;   
        MOVLW   24H
        CPFSLT  CHAS            ;     (CHAS)<24H
        CLRF    CHAS,F  ;   
        GOTO    M312

M310:   MOVLW   09H
        CPFSEQ  WORK    ;      ""
        GOTO    M320    ;  -   
        INCF    MIN,W   ;  ""
        DAW     MIN,F           ;   
        MOVLW   60H
        CPFSLT  MIN             ;     (MIN)<60H
        CLRF    MIN,F           ;   

M312:   CLRF    SEC,F   ;  ""
        BSF     FLAG,0  ;    ""
        GOTO    M400

M320:   MOVLW   04H
        CPFSEQ  WORK    ;      /  
        GOTO    M330    ;  -   
        BTG     FLAG,1  ;    /  
        BSF     FLAG,0  ;    "" (     )
        BTFSC   FLAG,1  ;    /  
        BTFSS   PAUSE,5 ;       
        GOTO    M400
        CALL    ClrScr ;   -          
        GOTO    M400

M330:   MOVLB   03H             ;  SFR Bank 3
        DECFSZ  WORK,F  ;     /   (01H)
        GOTO    M340    ;  -   

        BTFSS   TCON2,PWM1ON	;   1
        GOTO    M335    ;  - 1  (   )

        BCF     TCON2,PWM1ON	;  1
        GOTO    M400

M335:   MOVLW   low(StrtTBL)    ;   
        MOVWF   TBLPTRL
        MOVLW   high(StrtTBL)
        MOVWF   TBLPTRH
        TABLRD  1,1,WREG        ;       
        CLRF    PW1DCL          ;    1
        MOVLW   40H
        MOVWF   PW1DCH
        CLRF    DEL3_1,F        ; .     3
        BSF     TCON2,PWM1ON	;  1
        GOTO    M400

M340:   DECFSZ  WORK,F  ;     ./. .(02H)
        GOTO    M400    ;  -   

        BTFSC   TCON2,PWM2ON	;   2
        GOTO    M345    ;  - 2  (  )

        MOVLW   01H
        MOVWF   FNL     ;     (  )
        MOVWF   FNH
        CLRF    UkazF,F ;      (=00H)
        CLRF    PW2DCL,F        ;     2
        MOVLW   40H
        MOVWF   PW2DCH

M345:   BTG     TCON2,PWM2ON  ; / 2

;    
M400:   BTFSS   FLAG,1  ;    /  
        BTFSS   PAUSE,5 ;       
        GOTO    M100            ;  -   

        BTFSS   FLAG,0  ;    ""
        GOTO    M100
;     
        BCF     FLAG,0  ;    ""

        MOVLW   CHAS
        MOVWF   FSR1    ;  ""
        MOVLW   040H
        MOVWF   FSR0    ;     (FSR0-)

M410:   SWAPF   INDF1,W ;  
        CALL    ZNGen   ;     ()
        MOVWF   INDF0   ;      
        MOVFP   INDF1,WREG
        CALL    ZNGen
        MOVWF   INDF0   ;       
        BTFSC   FSR0,3  ;     
        GOTO    M100
        MOVLW   040H
        MOVWF   INDF0   ;   "-" (  )
        DECF    FSR1,F
        GOTO    M410
; *************************************************************************************
;          LED 
; *************************************************************************************
ClrScr: MOVLW   040H            ;    
        MOVWF   FSR0
ClrSc:  CLRF    INDF0,F ;     (FSR0-)
        BTFSS   FSR0,3
        GOTO    ClrSc
        RETURN
; *************************************************************************************
StrtTBL:
        Include ZVUK_m.asm
EndTBL:
        END





