;==========================================================================
;        MPASM
;==========================================================================
;----- Register Files -----------------------------------------------------

INDF0                           EQU     H'0000'
FSR0                            EQU     H'0001'
PCL                             EQU     H'0002'
PCLATH                          EQU     H'0003'
ALUSTA                          EQU     H'0004'
T0STA                           EQU     H'0005'
CPUSTA                          EQU     H'0006'
INTSTA                          EQU     H'0007'
INDF1                           EQU     H'0008'
FSR1                            EQU     H'0009'
WREG                            EQU     H'000A'
TMR0L                           EQU     H'000B'
TMR0H                           EQU     H'000C'
TBLPTRL                         EQU     H'000D'
TBLPTRH                         EQU     H'000E'
BSR                             EQU     H'000F'

;----- Bank 0 -------------------------------------------------------------

PORTA                           EQU     H'0010'
DDRB                            EQU     H'0011'
PORTB                           EQU     H'0012'
RCSTA                           EQU     H'0013'
RCSTA1                          EQU     H'0013'
RCREG                           EQU     H'0014'    ; Backward compatibility only
RCREG1                          EQU     H'0014'
TXSTA                           EQU     H'0015'    ; Backward compatibility only
TXSTA1                          EQU     H'0015'
TXREG                           EQU     H'0016'    ; Backward compatibility only
TXREG1                          EQU     H'0016'
SPBRG                           EQU     H'0017'    ; Backward compatibility only
SPBRG1                          EQU     H'0017'

;----- Bank 1 -------------------------------------------------------------

DDRC                            EQU     H'0110'
PORTC                           EQU     H'0111'
DDRD                            EQU     H'0112'
PORTD                           EQU     H'0113'
DDRE                            EQU     H'0114'
PORTE                           EQU     H'0115'
PIR                             EQU     H'0116'    ; Backward compatibility only
PIR1                            EQU     H'0116'
PIE                             EQU     H'0117'    ; Backward compatibility only
PIE1                            EQU     H'0117'

;----- Bank 2 -------------------------------------------------------------

TMR1                            EQU     H'0210'
TMR2                            EQU     H'0211'
TMR3L                           EQU     H'0212'
TMR3H                           EQU     H'0213'
PR1                             EQU     H'0214'
PR2                             EQU     H'0215'
PR3L                            EQU     H'0216'
PR3H                            EQU     H'0217'

CA1L                            EQU     H'0216'
CA1H                            EQU     H'0217'

;----- Bank 3 -------------------------------------------------------------

PW1DCL                          EQU     H'0310'
PW2DCL                          EQU     H'0311'
PW1DCH                          EQU     H'0312'
PW2DCH                          EQU     H'0313'
CA2L                            EQU     H'0314'
CA2H                            EQU     H'0315'
TCON1                           EQU     H'0316'
TCON2                           EQU     H'0317'

;----- Bank 4 -------------------------------------------------------------

PIR2                            EQU     H'0410'
PIE2                            EQU     H'0411'

RCSTA2                          EQU     H'0413'
RCREG2                          EQU     H'0414'
TXSTA2                          EQU     H'0415'
TXREG2                          EQU     H'0416'
SPBRG2                          EQU     H'0417'

;----- Bank 5 -------------------------------------------------------------

DDRF                            EQU     H'0510'
PORTF                           EQU     H'0511'
DDRG                            EQU     H'0512'
PORTG                           EQU     H'0513'
ADCON0                          EQU     H'0514'
ADCON1                          EQU     H'0515'
ADRESL                          EQU     H'0516'
ADRESH                          EQU     H'0517'

;----- Bank 6 -------------------------------------------------------------

SSPADD                          EQU     H'0610'
SSPCON1                         EQU     H'0611'
SSPCON2                         EQU     H'0612'
SSPSTAT                         EQU     H'0613'
SSPBUF                          EQU     H'0614'

;----- Bank 7 -------------------------------------------------------------

PW3DCL                          EQU     H'0710'
PW3DCH                          EQU     H'0711'
CA3L                            EQU     H'0712'
CA3H                            EQU     H'0713'
CA4L                            EQU     H'0714'
CA4H                            EQU     H'0715'
TCON3                           EQU     H'0716'
WRDIV					  EQU	    H'0717'

;----- Unbanked -----------------------------------------------------------

PRODL                           EQU     H'0018'
PL                              EQU     H'0018'    ; Backward compatibility only
PRODH                           EQU     H'0019'
PH                              EQU     H'0019'    ; Backward compatibility only

;----- Special Function Register Bit Definitions --------------------------
;
;----- ALUSTA Bits --------------------------------------------------------

#DEFINE FS3     ALUSTA,7
#DEFINE FS2     ALUSTA,6
#DEFINE FS1     ALUSTA,5
#DEFINE FS0     ALUSTA,4
#DEFINE OV      ALUSTA,3
#DEFINE Z       ALUSTA,2
#DEFINE DC      ALUSTA,1
#DEFINE C       ALUSTA,0

;----- CPUSTA Bits --------------------------------------------------------

#DEFINE STKAV      CPUSTA,5
#DEFINE GLINTD     CPUSTA,4
#DEFINE NOT_TO     CPUSTA,3
#DEFINE TO         CPUSTA,3
#DEFINE NOT_PD     CPUSTA,2
#DEFINE PD         CPUSTA,2
#DEFINE NOT_POR    CPUSTA,1
#DEFINE POR        CPUSTA,1
#DEFINE NOT_BOR    CPUSTA,0
#DEFINE BOR        CPUSTA,0

;----- INTSTA Bits --------------------------------------------------------

#DEFINE PEIF       INTSTA,7
#DEFINE T0CKIF     INTSTA,6
#DEFINE T0IF       INTSTA,5
#DEFINE INTF       INTSTA,4
#DEFINE PEIE       INTSTA,3
#DEFINE T0CKIE     INTSTA,2
#DEFINE T0IE       INTSTA,1
#DEFINE INTE       INTSTA,0

;----- PIR1 Bits ----------------------------------------------------------

#DEFINE RBIF       PIR1,7
#DEFINE TMR3IF     PIR1,6
#DEFINE TMR2IF     PIR1,5
#DEFINE TMR1IF     PIR1,4
#DEFINE CA2IF      PIR1,3
#DEFINE CA1IF      PIR1,2
; #DEFINE TXIF       PIR1,1 ; Backward compatibility only
#DEFINE TX1IF      PIR1,1
; #DEFINE RCIF       PIR1,0 ; Backward compatibility only
#DEFINE RC1IF      PIR1,0

;----- PIE1 Bits -----------------------------------------------------------

#DEFINE RBIE       PIE,7
#DEFINE TMR3IE     PIE,6
#DEFINE TMR2IE     PIE,5
#DEFINE TMR1IE     PIE,4
#DEFINE CA2IE      PIE,3
#DEFINE CA1IE      PIE,2
; #DEFINE TXIE       PIE,1 ; Backward compatibility only
#DEFINE TX1IE      PIE,1
; #DEFINE RCIE       PIE,0 ; Backward compatibility only
#DEFINE RC1IE      PIE,0

;----- PORTA Bits ---------------------------------------------------------

#DEFINE NOT_RBPU  PORTA,7
#DEFINE RBPU      PORTA,7
#DEFINE PORTA5	PORTA,5
#DEFINE PORTA4	PORTA,4
#DEFINE PORTA3	PORTA,3
#DEFINE PORTA2	PORTA,2
#DEFINE PORTA1	PORTA,1
#DEFINE PORTA0	PORTA,0

;----- RCSTA1 Bits -------------------------------------------------------

#DEFINE SPEN1      RCSTA1,7
#DEFINE RX91       RCSTA1,6
#DEFINE RC91       RCSTA1,6
#DEFINE NOT_RC81   RCSTA1,6
#DEFINE RC8_91     RCSTA1,6
#DEFINE SREN1      RCSTA1,5
#DEFINE CREN1      RCSTA1,4
#DEFINE FERR1      RCSTA1,2
#DEFINE OERR1      RCSTA1,1
#DEFINE RX9D1      RCSTA1,0
#DEFINE RCD81      RCSTA1,0

;----- RCSTA2 Bits -------------------------------------------------------

#DEFINE SPEN2      RCSTA2,7
#DEFINE RX92       RCSTA2,6
#DEFINE RC92       RCSTA2,6
#DEFINE NOT_RC82   RCSTA2,6
#DEFINE RC8_92     RCSTA2,6
#DEFINE SREN2      RCSTA2,5
#DEFINE CREN2      RCSTA2,4
#DEFINE FERR2      RCSTA2,2
#DEFINE OERR2      RCSTA2,1
#DEFINE RX9D2      RCSTA2,0
#DEFINE RCD82      RCSTA2,0

;----- RCSTA1 and 2 Bits --------------------------------------------------

#DEFINE SPEN      H'0007'
#DEFINE RX9       H'0006'
#DEFINE RC9       H'0006'
#DEFINE NOT_RC8   H'0006'
#DEFINE RC8_9     H'0006'
#DEFINE SREN      H'0005'
#DEFINE CREN      H'0004'
#DEFINE FERR      H'0002'
#DEFINE OERR      H'0001'
#DEFINE RX9D      H'0000'
#DEFINE RCD8      H'0000'


;----- T0STA Bits --------------------------------------------------------

#DEFINE INTEDG     T0STA,7
#DEFINE T0SE       T0STA,6
#DEFINE T0CS       T0STA,5
#DEFINE T0PS3      T0STA,4
#DEFINE PS3        T0STA,4
#DEFINE T0PS2      T0STA,3
#DEFINE PS2        T0STA,3
#DEFINE T0PS1      T0STA,2
#DEFINE PS1        T0STA,2
#DEFINE T0PS0      T0STA,1
#DEFINE PS0        T0STA,1

;----- TCON1 Bits ---------------------------------------------------------

#DEFINE CA2ED1     TCON1,7
#DEFINE CA2ED0     TCON1,6
#DEFINE CA1ED1     TCON1,5
#DEFINE CA1ED0     TCON1,4
#DEFINE T16        TCON1,3
#DEFINE TMR3CS     TCON1,2
#DEFINE TMR2CS     TCON1,1
#DEFINE TMR1CS     TCON1,0

;----- TCON2 Bits ---------------------------------------------------------

#DEFINE CA2OVF     TCON2,7
#DEFINE CA1OVF     TCON2,6
#DEFINE PWM2ON     TCON2,5
#DEFINE PWM1ON     TCON2,4
#DEFINE CA1        TCON2,3
#DEFINE NOT_PR3    TCON2,3
#DEFINE PR3        TCON2,3
#DEFINE CA1_PR3    TCON2,3
#DEFINE TMR3ON     TCON2,2
#DEFINE TMR2ON     TCON2,1
#DEFINE TMR1ON     TCON2,0

;----- PIR2 Bits ----------------------------------------------------------

#DEFINE SSPIF      PIR2,7
#DEFINE BCLIF      PIR2,6
#DEFINE ADIF       PIR2,5
#DEFINE CA4IF      PIR2,3
#DEFINE CA3IF      PIR2,2
#DEFINE TX2IF      PIR2,1
#DEFINE RC2IF      PIR2,0

;----- PIE2 Bits ----------------------------------------------------------

#DEFINE SSPIE      PIE2,7
#DEFINE BCLIE      PIE2,6
#DEFINE ADIE       PIE2,5
#DEFINE CA4IE      PIE2,3
#DEFINE CA3IE      PIE2,2
#DEFINE TX2IE      PIE2,1
#DEFINE RC2IE      PIE2,0

;----- TXSTA1 and 2 Bits --------------------------------------------------

#DEFINE CSRC       H'0007'
#DEFINE TX9        H'0006'
#DEFINE NOT_TX8    H'0006'    ; Backward compatibility only
#DEFINE TX8_9      H'0006'    ; Backward compatibility only
#DEFINE TXEN       H'0005'
#DEFINE SYNC       H'0004'
#DEFINE TRMT       H'0001'
#DEFINE TX9D       H'0000'
#DEFINE TXD8       H'0000'    ; Backward compatibility only

;----- TXSTA1 Bits --------------------------------------------------------

#DEFINE CSRC1      TXSTA1,7
#DEFINE TX91       TXSTA1,6
#DEFINE NOT_TX81   TXSTA1,6
#DEFINE TX8_91     TXSTA1,6
#DEFINE TXEN1      TXSTA1,5
#DEFINE SYNC1      TXSTA1,4
#DEFINE TRMT1      TXSTA1,1
#DEFINE TX9D1      TXSTA1,0
#DEFINE TXD81      TXSTA1,0

;----- TXSTA2 Bits --------------------------------------------------------

#DEFINE CSRC2       TXSTA2,7
#DEFINE TX92        TXSTA2,6
#DEFINE NOT_TX82    TXSTA2,6
#DEFINE TX8_92      TXSTA2,6
#DEFINE TXEN2       TXSTA2,5
#DEFINE SYNC2       TXSTA2,4
#DEFINE TRMT2       TXSTA2,1
#DEFINE TX9D2       TXSTA2,0
#DEFINE TXD82       TXSTA2,0

;----- ADCON0 Bits --------------------------------------------------------

#DEFINE CHS3        ADCON0,7
#DEFINE CHS2        ADCON0,6
#DEFINE CHS1        ADCON0,5
#DEFINE CHS0        ADCON0,4
#DEFINE GO          ADCON0,2
#DEFINE NOT_DONE    ADCON0,2
#DEFINE DONE        ADCON0,2
#DEFINE ADON        ADCON0,0

;----- ADCON1 Bits --------------------------------------------------------

#DEFINE ADCS1       ADCON1,7
#DEFINE ADCS0       ADCON1,6
#DEFINE ADFM        ADCON1,5
#DEFINE PCFG3       ADCON1,3
#DEFINE PCFG2       ADCON1,2
#DEFINE PCFG1       ADCON1,1
#DEFINE PCFG0       ADCON1,0

;----- SSPCON1 Bits -------------------------------------------------------

#DEFINE WCOL        SSPCON1,7
#DEFINE SSPOV       SSPCON1,6
#DEFINE SSPEN       SSPCON1,5
#DEFINE CKP         SSPCON1,4
#DEFINE SSPM3       SSPCON1,3
#DEFINE SSPM2       SSPCON1,2
#DEFINE SSPM1       SSPCON1,1
#DEFINE SSPM0       SSPCON1,0

;----- SSPCON2 Bits -------------------------------------------------------

#DEFINE GCEN        SSPCON2,7
#DEFINE ACKSTAT     SSPCON2,6
#DEFINE AKSTAT      SSPCON2,6
#DEFINE ACKDT       SSPCON2,5
#DEFINE AKDT        SSPCON2,5
#DEFINE ACKEN       SSPCON2,4
#DEFINE AKEN        SSPCON2,4
#DEFINE RCEN        SSPCON2,3
#DEFINE PEN         SSPCON2,2
#DEFINE RSEN        SSPCON2,1
#DEFINE SEN         SSPCON2,0

;----- SSPSTAT Bits -------------------------------------------------------

#DEFINE SMP         SSPSTAT,7
#DEFINE CKE         SSPSTAT,6
#DEFINE D           SSPSTAT,5
#DEFINE NOT_A       SSPSTAT,5
#DEFINE D_A         SSPSTAT,5
#DEFINE P           SSPSTAT,4
#DEFINE S           SSPSTAT,3
#DEFINE R           SSPSTAT,2
#DEFINE NOT_W       SSPSTAT,2
#DEFINE R_W         SSPSTAT,2
#DEFINE UA          SSPSTAT,1
#DEFINE BF          SSPSTAT,0

;----- TCON3 Bits ---------------------------------------------------------

#DEFINE CA4OVF      TCON3,6
#DEFINE CA3OVF      TCON3,5
#DEFINE CA4ED1      TCON3,4
#DEFINE CA4ED0      TCON3,3
#DEFINE CA3ED1      TCON3,2
#DEFINE CA3ED0      TCON3,1
#DEFINE PWM3ON      TCON3,0

;----- PW2DCL Bit ---------------------------------------------------------

#DEFINE TM2PW2      PW2DCL,5


;----- PW3DCL Bit ---------------------------------------------------------

#DEFINE TM2PW3      PW3DCL,5


W                               EQU     H'0000'
F                               EQU     H'0001'

BANK0                           EQU     H'0000'
BANK1                           EQU     H'0001'
BANK2                           EQU     H'0002'
BANK3                           EQU     H'0003'
BANK4                           EQU     H'0004'
BANK5                           EQU     H'0005'
BANK6                           EQU     H'0006'
BANK7                           EQU     H'0007'

Bank0                           EQU     H'0000'
Bank1                           EQU     H'0001'
Bank2                           EQU     H'0002'
Bank3                           EQU     H'0003'
Bank4                           EQU     H'0004'
Bank5                           EQU     H'0005'
Bank6                           EQU     H'0006'
Bank7                           EQU     H'0007'

GPR_BANK0                       EQU    H'0000'
GPR_BANK1                       EQU    H'0008'
GPR_BANK2                       EQU    H'0010'
GPR_BANK3                       EQU    H'0018'

;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM        H'8FF'
        __BADRAM        H'118'-H'11F', H'218'-H'21F', H'318'-H'31F'
        __BADRAM        H'412', H'418'-H'4FF'
        __BADRAM        H'518'-H'5FF'
        __BADRAM        H'615'-H'6FF'
        __BADRAM        H'717'-H'7FF'
        __BADRAM        H'814'-H'8FF'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

_PMC_MODE                       EQU     H'7FAF'
_XMC_MODE                       EQU     H'FFBF'
_MC_MODE                        EQU     H'FFEF'
_MP_MODE                        EQU     H'FFFF'

_BODEN_OFF                      EQU     H'BFFF'
_BODEN_ON                       EQU     H'FFFF'

_WDT_NORM                       EQU     H'FFF3'
_WDT_OFF                        EQU     H'FFF3'
_WDT_64                         EQU     H'FFF7'
_WDT_256                        EQU     H'FFFB'
_WDT_1                          EQU     H'FFFF'
_WDT_0                          EQU     H'FFFF'

_LF_OSC                         EQU     H'FFFC'
_RC_OSC                         EQU     H'FFFD'
_XT_OSC                         EQU     H'FFFE'
_EC_OSC                         EQU     H'FFFF'

        LIST
