;==========================================================================
;		 MPASM (Microchip)
;==========================================================================

INDF0		EQU		000H
FSR0		EQU		001H
PCL		EQU		002H
PCLATH	EQU		003H
ALUSTA	EQU		004H

;	ALUSTA bits:
#DEFINE	C		ALUSTA,0
#DEFINE	DC		ALUSTA,1
#DEFINE	Z		ALUSTA,2
#DEFINE	OV		ALUSTA,3
#DEFINE	FS0		ALUSTA,4
#DEFINE	FS1		ALUSTA,5
#DEFINE	FS2		ALUSTA,6
#DEFINE	FS3		ALUSTA,7

T0STA		EQU	005H

;	T0STA bits:
#DEFINE	T0PS0		T0STA,1
#DEFINE	T0PS1		T0STA,2
#DEFINE	T0PS2		T0STA,3
#DEFINE	T0PS3		T0STA,4
#DEFINE	T0CS		T0STA,5
#DEFINE	T0SE		T0STA,6
#DEFINE	INTEDG	T0STA,7

CPUSTA	EQU		006H

;	CPUSTA bits:
#DEFINE	BOR		CPUSTA,0
#DEFINE	POR		CPUSTA,1
#DEFINE	NOT_PD	CPUSTA,2
#DEFINE	NOT_TO	CPUSTA,3
#DEFINE	PD		CPUSTA,2
#DEFINE	TO		CPUSTA,3
#DEFINE	GLINTD	CPUSTA,4
#DEFINE	STKAV		CPUSTA,5

INTSTA	EQU		007H

;	INTSTA bits:
#DEFINE	INTE		INTSTA,0
#DEFINE	T0IE		INTSTA,1
#DEFINE	T0CKIE	INTSTA,2
#DEFINE	PEIE		INTSTA,3
#DEFINE	INTF		INTSTA,4
#DEFINE	T0IF		INTSTA,5
#DEFINE	T0CKIF	INTSTA,6
#DEFINE	PEIF		INTSTA,7

INDF1		EQU		008H
FSR1		EQU		009H
WREG		EQU		00AH
TMR0L		EQU		00BH
TMR0H		EQU		00CH
TBLPTRL	EQU		00DH
TBLPTRH	EQU		00EH
BSR		EQU		00FH

;----- Bank 0 -------------------------------------------------------------

EP1_CFG1	EQU		010H
EP1_CFG2	EQU		011H
EP2_CFG1	EQU		012H
EP2_CFG2	EQU		013H
EP3_CFG1	EQU		014H
EP3_CFG2	EQU		015H
EP4_CFG1	EQU		016H
EP4_CFG2	EQU		017H

;----- Bank 1 -------------------------------------------------------------

DESC_ADR	EQU		110H
DESC_DATA	EQU		111H
PORTA		EQU		112H

;	PORTA bits:
#DEFINE	PORTA0	PORTA,0
#DEFINE	PORTA1	PORTA,1
#DEFINE	PORTA2	PORTA,2
#DEFINE	PORTA3	PORTA,3

DDRD		EQU		113H
PORTD		EQU		114H

;	PORTD bits:
#DEFINE	PORTD0	PORTD,0
#DEFINE	PORTD1	PORTD,1
#DEFINE	PORTD2	PORTD,2
#DEFINE	PORTD3	PORTD,3
#DEFINE	PORTD4	PORTD,4
#DEFINE	PORTD5	PORTD,5
#DEFINE	PORTD6	PORTD,6
#DEFINE	PORTD7	PORTD,7

DDRC		EQU		115H
PORTC		EQU		116H

;	PORTC bits:
#DEFINE	PORTC0	PORTC,0
#DEFINE	PORTC1	PORTC,1
#DEFINE	PORTC2	PORTC,2
#DEFINE	PORTC3	PORTC,3
#DEFINE	PORTC4	PORTC,4
#DEFINE	PORTC5	PORTC,5
#DEFINE	PORTC6	PORTC,6
#DEFINE	PORTC7	PORTC,7

;----- Bank 2 -------------------------------------------------------------

EP1_REG	EQU		210H
EP2_REG 	EQU		211H
EP3_REG	EQU		212H
EP4_REG 	EQU		213H
PIR1		EQU		214H

;	PIR1 bits:
#DEFINE	RCIF		PIR1,0
#DEFINE	TXIF		PIR1,1
#DEFINE	USBIF		PIR1,2
#DEFINE	NANDIF	PIR1,3
#DEFINE	EEPROMIF	PIR1,4
#DEFINE	SPIIF		PIR1,5

#DEFINE	UsbIF		PIR1,2
#DEFINE	NandIF	PIR1,3
#DEFINE	EepromIF	PIR1,4

PIE1		EQU		215H

;	PIE1 bits:
#DEFINE	RCIE		PIE1,0
#DEFINE	TXIE		PIE1,1
#DEFINE	UsbIE		PIE1,2
#DEFINE	NandIE	PIE1,3
#DEFINE	EepromIE	PIE1,4
#DEFINE	SPIIE		PIE1,5

#DEFINE	USBIE		PIE1,2
#DEFINE	NANDIE	PIE1,3
#DEFINE	EEPROMIE	PIE1,4

;----- Bank 3 -------------------------------------------------------------

EP1_STAT	EQU		310H

;	EP1_STAT bits:
#DEFINE	EMPTY1	EP1_STAT,0
#DEFINE	FULL1		EP1_STAT,1
#DEFINE	ACTIVE1	EP1_STAT,4
#DEFINE	BLK1_DATA	EP1_STAT,5

EP2_STAT	EQU		311H

;	EP2_STAT bits:
#DEFINE	EMPTY2	EP2_STAT,0
#DEFINE	FULL2		EP2_STAT,1
#DEFINE	ACTIVE2	EP2_STAT,4
#DEFINE	BLK2_DATA	EP2_STAT,5

EP3_STAT	EQU		312H

;	EP3_STAT bits:
#DEFINE	EMPTY3	EP3_STAT,0
#DEFINE	FULL3		EP3_STAT,1
#DEFINE	ACTIVE3	EP3_STAT,4
#DEFINE	BLK3_DATA	EP3_STAT,5

EP4_STAT	EQU		313H

;	EP4_STAT bits:
#DEFINE	EMPTY4	EP4_STAT,0
#DEFINE	FULL4		EP4_STAT,1
#DEFINE	ACTIVE4	EP4_STAT,4
#DEFINE	BLK4_DATA	EP4_STAT,5

EP1_CNT	EQU		314H
EP2_CNT	EQU		315H
EP3_CNT	EQU		316H
EP4_CNT	EQU		317H

;----- Bank 4 -------------------------------------------------------------

USB_ADR	EQU		410H
USB_ERROR	EQU		411H
USB_STAT	EQU		412H
USB_CTRL	EQU		413H
USB_IE1	EQU		414H
USB_IE2	EQU		415H
USB_IE3	EQU		416H
USB_IE4	EQU		417H

;----- Bank 5 -------------------------------------------------------------

DDRE		EQU		511H
PORTE		EQU		512H

;	PORTE bits:
#DEFINE	PORTE0	PORTE,0
#DEFINE	PORTE1	PORTE,1
#DEFINE	PORTE2	PORTE,2
#DEFINE	PORTE3	PORTE,3
#DEFINE	PORTE4	PORTE,4
#DEFINE	PORTE5	PORTE,5
#DEFINE	PORTE6	PORTE,6
#DEFINE	PORTE7	PORTE,7

RCSTA1	EQU		513H
RCSTA		EQU		513H

;	RCSTA bits:
#DEFINE	RX9D		RCSTA,0
#DEFINE	OERR		RCSTA,1
#DEFINE	FERR		RCSTA,2
#DEFINE	CREN		RCSTA,4
#DEFINE	SREN		RCSTA,5
#DEFINE	RX9		RCSTA,6
#DEFINE	SPEN		RCSTA,7

RCREG1	EQU		514H
RCREG		EQU		514H
TXSTA1	EQU		515H
TXSTA		EQU		515H

;	TXSTA bits:
#DEFINE	TX9D		TXSTA,0
#DEFINE	TRMT		TXSTA,1
#DEFINE	SYNC		TXSTA,4
#DEFINE	TXEN		TXSTA,5
#DEFINE	TX9		TXSTA,6
#DEFINE	CSRC		TXSTA,7

TXREG1	EQU		516H
TXREG		EQU		516H
SPBRG1	EQU		517H
SPBRG		EQU		517H

;----- Bank 6 -------------------------------------------------------------

NAND_MODE	EQU		610H
NAND_DATA	EQU		611H
WRDIF		EQU		613H
EEPROM_CONT	EQU		614H
EEPROM_MODE	EQU		615H
EEPROM_DATA	EQU		616H
EEPROM_ADDR	EQU		617H

;----- Bank 7 -------------------------------------------------------------

SSPCON1		EQU	711H
SSPSTAT		EQU	713H
SSPBUF		EQU	714H

;----- Unbanked -----------------------------------------------------------

PRODL		EQU	018H
PRODH		EQU	019H

;--------------------------------------------------------------------------

W		EQU	000H
F		EQU	001H

Bank0		EQU	000H
Bank1		EQU	001H
Bank2		EQU	002H
Bank3		EQU	003H
Bank4		EQU	004H
Bank5		EQU	005H
Bank6		EQU	006H
Bank7		EQU	007H

BANK0		EQU	000H
BANK1		EQU	001H
BANK2		EQU	002H
BANK3		EQU	003H
BANK4		EQU	004H
BANK5		EQU	005H
BANK6		EQU	006H
BANK7		EQU	007H
; ==========================================================================
