        NOLIST

; Note that the processor must be selected before this file is 
; included.  The processor may be selected the following ways:

;       1. Command line switch:
;               C:\ MPASM MYFILE.ASM /PIC17C756A
;       2. LIST directive in the source file
;               LIST   P=PIC17C756A
;       3. Processor Type entry in the MPASM full-screen interface

;==========================================================================
;
;       Register Definitions
;
;==========================================================================

W                               EQU     H'0000'
F                               EQU     H'0001'

BANK0                           EQU     H'0000'
BANK1                           EQU     H'0001'
BANK2                           EQU     H'0002'
BANK3                           EQU     H'0003'
BANK4                           EQU     H'0004'
BANK5                           EQU     H'0005'
BANK6                           EQU     H'0006'
BANK7                           EQU     H'0007'
BANK8                           EQU     H'0008'
BANK9                           EQU     H'0009'
BANK14                          EQU     0EH
BANK15                          EQU     0FH


GPR_BANK0                       EQU    H'0000'
GPR_BANK1                       EQU    H'0008'
GPR_BANK2                       EQU    H'0010'
GPR_BANK3                       EQU    H'0018'

;----- Register Files -----------------------------------------------------

INDF0                           EQU     H'0000'
FSR0                            EQU     H'0001'
PCL                             EQU     H'0002'
PCLATH                          EQU     H'0003'

ALUSTA                          EQU     H'0004'

;	ALUSTA bits:
#DEFINE	C		ALUSTA,0
#DEFINE	CARRY		ALUSTA,0
#DEFINE	DC		ALUSTA,1
#DEFINE	Z		ALUSTA,2
#DEFINE	ZERO		ALUSTA,2
#DEFINE	OV		ALUSTA,3
#DEFINE	FS0		ALUSTA,4
#DEFINE	FS1		ALUSTA,5
#DEFINE	FS2		ALUSTA,6
#DEFINE	FS3		ALUSTA,7


T0STA		EQU		H'0005'

;	T0STA bits:
#DEFINE	PS0		T0STA,1
#DEFINE	PS1		T0STA,2
#DEFINE	PS2		T0STA,3
#DEFINE	PS3		T0STA,4
#DEFINE	T0PS0		T0STA,1
#DEFINE	T0PS1		T0STA,2
#DEFINE	T0PS2		T0STA,3
#DEFINE	T0PS3		T0STA,4
#DEFINE	T0CS		T0STA,5
#DEFINE	T0SE		T0STA,6
#DEFINE	INTEDG	T0STA,7

CPUSTA	EQU		H'0006'

;	CPUSTA bits:
#DEFINE	BOR		CPUSTA,0
#DEFINE	POR		CPUSTA,1
#DEFINE	PD		CPUSTA,2
#DEFINE	TO		CPUSTA,3
#DEFINE	GLINTD	CPUSTA,4
#DEFINE	STKAV		CPUSTA,5
#DEFINE	ESLP		CPUSTA,6

INTSTA	EQU		H'0007'

;	INTSTA bits:
#DEFINE	INTE		INTSTA,0
#DEFINE	T0IE		INTSTA,1
#DEFINE	T0CKIE	INTSTA,2
#DEFINE	PEIE		INTSTA,3
#DEFINE	INTF		INTSTA,4
#DEFINE	T0IF		INTSTA,5
#DEFINE	T0CKIF	INTSTA,6
#DEFINE	PEIF		INTSTA,7

INDF1		EQU		H'0008'
FSR1		EQU		H'0009'
WREG		EQU		H'000A'
TMR0L		EQU		H'000B'
TMR0H		EQU		H'000C'
TBLPTRL	EQU		H'000D'
TBLPTRH	EQU		H'000E'
BSR		EQU		H'000F'

;----- Bank 0 -------------------------------------------------------------

LIN_CTRL	EQU		011H
LIN_CNTR	EQU		011H

;	LIN_CNTR bits:
#DEFINE	LINEN		LIN_CTRL,0
#DEFINE	ERR		LIN_CTRL,1
#DEFINE	SYNCH		LIN_CTRL,2
#DEFINE	BRK		LIN_CTRL,3
#DEFINE	BRKCNT0	LIN_CTRL,4
#DEFINE	BRKCNT1	LIN_CTRL,5
#DEFINE	BRKCNT2	LIN_CTRL,6
#DEFINE	BRKCNT3	LIN_CTRL,7

LIN_BRG	EQU		012H

RCSTA		EQU		H'0013'
RCSTA1	EQU		H'0013'

;	RCSTA bits:
#DEFINE	RX9D1		RCSTA,0
#DEFINE	OERR1		RCSTA,1
#DEFINE	FERR1		RCSTA,2
#DEFINE	CREN1		RCSTA,4
#DEFINE	SREN1		RCSTA,5
#DEFINE	RX91		RCSTA,6
#DEFINE	SPEN1		RCSTA,7

#DEFINE	RX9D		RCSTA,0
#DEFINE	OERR		RCSTA,1
#DEFINE	FERR		RCSTA,2
#DEFINE	CREN		RCSTA,4
#DEFINE	SREN		RCSTA,5
#DEFINE	RX9		RCSTA,6
#DEFINE	SPEN		RCSTA,7

RCREG		EQU		H'0014'    ; Backward compatibility only
RCREG1	EQU		H'0014'
TXSTA		EQU		H'0015'    ; Backward compatibility only
TXSTA1	EQU		H'0015'


;	TXSTA bits:
#DEFINE	TX9D1		TXSTA,0
#DEFINE	TRMT1		TXSTA,1
#DEFINE	SYNC1		TXSTA,4
#DEFINE	TXEN1		TXSTA,5
#DEFINE	TX91		TXSTA,6
#DEFINE	CSRC1		TXSTA,7

#DEFINE	TX9D		TXSTA,0
#DEFINE	TRMT		TXSTA,1
#DEFINE	SYNC		TXSTA,4
#DEFINE	TXEN		TXSTA,5
#DEFINE	TX9		TXSTA,6
#DEFINE	CSRC		TXSTA,7

TXREG		EQU		H'0016'    ; Backward compatibility only
TXREG1	EQU		H'0016'
SPBRG		EQU		H'0017'    ; Backward compatibility only
SPBRG1	EQU		H'0017'

;----- Bank 1 -------------------------------------------------------------

DDRA        EQU   0x110
PORTA       EQU   0x111

;	PORTA bits:
#DEFINE	PORTA0	PORTA,0
#DEFINE	PORTA1	PORTA,1
#DEFINE	PORTA2	PORTA,2
#DEFINE	PORTA3	PORTA,3
#DEFINE	PORTA4	PORTA,4
#DEFINE	PORTA5	PORTA,5

DDRC        EQU   0x112
PORTC       EQU   0x113

;	PORTC bits:
#DEFINE	PORTC0	PORTC,0
#DEFINE	PORTC1	PORTC,1
#DEFINE	PORTC2	PORTC,2
#DEFINE	PORTC3	PORTC,3
#DEFINE	PORTC4	PORTC,4
#DEFINE	PORTC5	PORTC,5
#DEFINE	PORTC6	PORTC,6
#DEFINE	PORTC7	PORTC,7

DDRD        EQU   0x114
PORTD       EQU   0x115

;	PORTD bits:
#DEFINE	PORTD0	PORTD,0
#DEFINE	PORTD1	PORTD,1
#DEFINE	PORTD2	PORTD,2
#DEFINE	PORTD3	PORTD,3
#DEFINE	PORTD4	PORTD,4
#DEFINE	PORTD5	PORTD,5
#DEFINE	PORTD6	PORTD,6
#DEFINE	PORTD7	PORTD,7

DDRE        EQU   0x116
PORTE       EQU   0x117

;	PORTE bits:
#DEFINE	PORTE0	PORTE,0
#DEFINE	PORTE1	PORTE,1
#DEFINE	PORTE2	PORTE,2
#DEFINE	PORTE3	PORTE,3

;----- Bank 2 -------------------------------------------------------------

TMR1		EQU	H'0210'

TMR3L		EQU	H'0212'
TMR3H		EQU	H'0213'
TMR2L		EQU	H'0212'
TMR2H		EQU	H'0213'

PR1		EQU	H'0214'

PR3L		EQU	H'0216'
PR3H		EQU	H'0217'

PR2L		EQU	H'0216'
PR2H		EQU	H'0217'

CA1L		EQU	H'0216'
CA1H		EQU	H'0217'

;----- Bank 3 -------------------------------------------------------------

PW1DCL	EQU		H'0310'

;	PW1DCL bits
#DEFINE	DC1PW1	PW1DCL,7
#DEFINE	DC0PW1	PW1DCL,6

PW2DCL	EQU		H'0311'

;	PW2DCL bits
#DEFINE	DC1PW2	PW2DCL,7
#DEFINE	DC0PW2	PW2DCL,6

PW1DCH	EQU		H'0312'

;	PW1DCH bits
#DEFINE	DC9PW1	PW1DCH,7
#DEFINE	DC8PW1	PW1DCH,6
#DEFINE	DC7PW1	PW1DCH,5
#DEFINE	DC6PW1	PW1DCH,4
#DEFINE	DC5PW1	PW1DCH,3
#DEFINE	DC4PW1	PW1DCH,2
#DEFINE	DC3PW1	PW1DCH,1
#DEFINE	DC2PW1	PW1DCH,0

PW2DCH	EQU		H'0313'

;	PW2DCH bits
#DEFINE	DC9PW2	PW2DCH,7
#DEFINE	DC8PW2	PW2DCH,6
#DEFINE	DC7PW2	PW2DCH,5
#DEFINE	DC6PW2	PW2DCH,4
#DEFINE	DC5PW2	PW2DCH,3
#DEFINE	DC4PW2	PW2DCH,2
#DEFINE	DC3PW2	PW2DCH,1
#DEFINE	DC2PW2	PW2DCH,0

CA2L		EQU		H'0314'
CA2H		EQU		H'0315'

TCON1		EQU		H'0316'

;	TCON1 bits:
#DEFINE	TMR1CS	TCON1,0
#DEFINE	TMR2CS	TCON1,2
#DEFINE	CA1ED0	TCON1,4
#DEFINE	CA1ED1	TCON1,5
#DEFINE	CA2ED0	TCON1,6
#DEFINE	CA2ED1	TCON1,7

TCON2		EQU		H'0317'

;	TCON2 bits:
#DEFINE	TMR1ON	TCON2,0
#DEFINE	TMR2ON	TCON2,2
#DEFINE	CA1_PR2	TCON2,3
#DEFINE	CA1		TCON2,3
#DEFINE	PWM1ON	TCON2,4
#DEFINE	PWM2ON	TCON2,5
#DEFINE	CA1OVF	TCON2,6
#DEFINE	CA2OVF	TCON2,7

;----- Bank 4 -------------------------------------------------------------

CANMASK11_21	EQU	410H
CANMASK12_22	EQU	411H
CANMASK13_23	EQU	412H
CANMASK14_24	EQU	413H
CANFLTR11_21	EQU	414H
CANFLTR12_22	EQU	415H
CANFLTR13_23	EQU	416H
CANFLTR14_24	EQU	417H

CAN_MASK11_21	EQU	410H
CAN_MASK12_22	EQU	411H
CAN_MASK13_23	EQU	412H
CAN_MASK14_24	EQU	413H
CAN_FLTR11_21	EQU	414H
CAN_FLTR12_22	EQU	415H
CAN_FLTR13_23	EQU	416H
CAN_FLTR14_24	EQU	417H

CAN_MASK11		EQU	410H
CAN_MASK12		EQU	411H
CAN_MASK13		EQU	412H
CAN_MASK14		EQU	413H
CAN_FLTR11		EQU	414H
CAN_FLTR12		EQU	415H
CAN_FLTR13		EQU	416H
CAN_FLTR14		EQU	417H
	
;----- Bank 5 -------------------------------------------------------------

PIR1		EQU	510H

;	PIR1 bits:
#DEFINE	RCIF		PIR1,0
#DEFINE	TXIF		PIR1,1
#DEFINE	RC1IF		PIR1,0
#DEFINE	TX1IF		PIR1,1

#DEFINE	CAP1IF	PIR1,2
#DEFINE	CAP2IF	PIR1,3
#DEFINE	CA1IF		PIR1,2
#DEFINE	CA2IF		PIR1,3

#DEFINE	TMR1IF	PIR1,4
#DEFINE	TMR2IF	PIR1,5
#DEFINE	T1IF		PIR1,4
#DEFINE	T2IF		PIR1,5

#DEFINE	ADCIF		PIR1,6
#DEFINE	EEPROMIF	PIR1,7

PIE1		EQU	511H

;	PIE1 bits:
#DEFINE	RC1IE		PIE1,0
#DEFINE	TX1IE		PIE1,1
#DEFINE	RCIE		PIE1,0
#DEFINE	TXIE		PIE1,1

#DEFINE	CAP1IE	PIE1,2
#DEFINE	CAP2IE	PIE1,3
#DEFINE	CA1IE		PIE1,2
#DEFINE	CA2IE		PIE1,3

#DEFINE	TMR1IE	PIE1,4
#DEFINE	TMR2IE	PIE1,5
#DEFINE	T1IE		PIE1,4
#DEFINE	T2IE		PIE1,5

#DEFINE	ADCIE		PIE1,6
#DEFINE	EEPROMIE	PIE1,7

PIR2		EQU	512H

;	PIR2 bits:
#DEFINE	CANB0IF	PIR2,0
#DEFINE	CANB1IF	PIR2,1
#DEFINE	CANB2IF	PIR2,2
#DEFINE	CANB3IF	PIR2,3
#DEFINE	CANB4IF	PIR2,4
#DEFINE	CANB5IF	PIR2,5

PIE2		EQU	513H

;	PIE2 bits:
#DEFINE	CANB0IE	PIE2,0
#DEFINE	CANB1IE	PIE2,1
#DEFINE	CANB2IE	PIE2,2
#DEFINE	CANB3IE	PIE2,3
#DEFINE	CANB4IE	PIE2,4
#DEFINE	CANB5IE	PIE2,5

EE_CONT	EQU		514H
EE_CON	EQU		514H

;	EE_CONT bits:
#DEFINE	BRG0		EE_CONT,0
#DEFINE	BRG1		EE_CONT,1
#DEFINE	BRG2		EE_CONT,2
#DEFINE	VEE1		EE_CONT,3
#DEFINE	VEE2		EE_CONT,4
#DEFINE	CPTEST	EE_CONT,5
#DEFINE	EETEST	EE_CONT,6
#DEFINE	TEST_p	EE_CONT,7
#DEFINE	TEST_P	EE_CONT,7

EE_MODE	EQU		515H

;	EE_MODE bits:
#DEFINE	EE_MODE0	EE_MODE,0
#DEFINE	EE_MODE1	EE_MODE,1
#DEFINE	EE_MODE2	EE_MODE,2
#DEFINE	BUSY		EE_MODE,4
#DEFINE	IE_BUSY	EE_MODE,5
#DEFINE	EE_EN		EE_MODE,7
#DEFINE	EE_BUSY	EE_MODE,4

#DEFINE	MODE0		EE_MODE,0
#DEFINE	MODE1		EE_MODE,1
#DEFINE	MODE2		EE_MODE,2
#DEFINE	IEBUSY	EE_MODE,5

EE_DATA	EQU		516H
EE_ADR	EQU		517H

;----- Bank 6 -------------------------------------------------------------

DBH		EQU		610H
DBL		EQU		611H
EE_DIV	EQU		613H
EEDIV		EQU		613H

ADCON0	EQU		614H

;	ADCON0 bits:
#DEFINE	ADON		ADCON0,0
#DEFINE	GO_DONE	ADCON0,2
#DEFINE	GO		ADCON0,2
#DEFINE	CHS0		ADCON0,4
#DEFINE	CHS1		ADCON0,5
#DEFINE	CHS2		ADCON0,6


ADCON1	EQU		615H

;	ADCON1 bits:
#DEFINE	PCFG0		ADCON1,0
#DEFINE	PCFG1		ADCON1,1
#DEFINE	PCFG2		ADCON1,2
#DEFINE	PCFG3		ADCON1,3
#DEFINE	ADFM		ADCON1,5
#DEFINE	ADCS0		ADCON1,6
#DEFINE	ADCS1		ADCON1,7

ADRESL	EQU		616H
ADRESH	EQU		617H

;----- Bank 7 -------------------------------------------------------------

CANCNTR	EQU		710H
CAN_CNTR	EQU		710H
CAN_CONTR	EQU		710H

;	CANCNTR bits:
#DEFINE	CANEN		CANCNTR,0
#DEFINE	ROM		CANCNTR,1
#DEFINE	STM		CANCNTR,2
#DEFINE	SAP		CANCNTR,3
#DEFINE	ROP		CANCNTR,4
#DEFINE	OVLSEND	CANCNTR,5
#DEFINE	ERR0		CANCNTR,6
#DEFINE	ERR1		CANCNTR,7

#DEFINE	OVL_SEND	CANCNTR,5
#DEFINE	ERR_STATE0	CANCNTR,6
#DEFINE	ERR_STATE1	CANCNTR,7

CANSTAT	EQU		711H
CAN_STAT	EQU		711H

;	CANSTAT bits:
#DEFINE	RXBITERR	CANSTAT,0
#DEFINE	CRCERR	CANSTAT,1
#DEFINE	FRAMEERR	CANSTAT,2
#DEFINE	STUFFERR	CANSTAT,3
#DEFINE	TXBUSY	CANSTAT,4
#DEFINE	RXBUSY	CANSTAT,5
#DEFINE	TEC8		CANSTAT,6
#DEFINE	REC8		CANSTAT,7

CANBRG1	EQU		712H
CAN_BRG1	EQU		712H

;	CANBRG1 bits:
#DEFINE	SJW1		CANBRG1,7
#DEFINE	SJW0		CANBRG1,6
#DEFINE	BRP5		CANBRG1,5
#DEFINE	BRP4		CANBRG1,4
#DEFINE	BRP3		CANBRG1,3
#DEFINE	BRP2		CANBRG1,2
#DEFINE	BRP1		CANBRG1,1
#DEFINE	BRP0		CANBRG1,0

CANBRG2	EQU		713H
CAN_BRG2	EQU		713H

;	CANBRG2 bits:
#DEFINE	SAM		CANBRG2,6
#DEFINE	SEG12		CANBRG2,5
#DEFINE	SEG11		CANBRG2,4
#DEFINE	SEG10		CANBRG2,3
#DEFINE	PRSEG2	CANBRG2,2
#DEFINE	PRSEG1	CANBRG2,1
#DEFINE	PRSEG0	CANBRG2,0

CANBRG3	EQU		714H
CAN_BRG3	EQU		714H

;	CANBRG3 bits:
#DEFINE	SEG22		CANBRG3,2
#DEFINE	SEG21		CANBRG3,1
#DEFINE	SEG20		CANBRG3,0

CANBSR	EQU		715H
CAN_BSR	EQU		715H

;	CANBSR bits:
#DEFINE	MSL		CANBSR,4
#DEFINE	BSR2		CANBSR,2
#DEFINE	BSR1		CANBSR,1
#DEFINE	BSR0		CANBSR,0


CANERXCNT		EQU	716H
CAN_RXERRCNT	EQU	716H

CANETXCNT		EQU	717H
CAN_TXERRCNT	EQU	717H

;----- Bank 8 -------------------------------------------------------------

CANRXCS	EQU		810H
CAN_RXCS	EQU		810H
CAN_RXST	EQU		810H
CAN_RXSTAT	EQU		810H

;	CAN_RXCS bits:
#DEFINE	MASKACTID0	CAN_RXCS,0
#DEFINE	MASKACTID1	CAN_RXCS,1
#DEFINE	MASKACTID2	CAN_RXCS,2
#DEFINE	OFEN		CAN_RXCS,3
#DEFINE	OF		CAN_RXCS,4
#DEFINE	RXRTR		CAN_RXCS,5
#DEFINE	BITERR	CAN_RXCS,6
#DEFINE	RXFULL	CAN_RXCS,7

CANTXCS	EQU		811H
CAN_TXCS	EQU		811H
CAN_TXST	EQU		811H
CAN_TXSTAT	EQU		811H

;	CAN_TXCS bits:
#DEFINE	PRIOR0	CAN_TXCS,0
#DEFINE	PRIOR1	CAN_TXCS,1
#DEFINE	RTREN		CAN_TXCS,2
#DEFINE	TXREQ		CAN_TXCS,3
#DEFINE	TXERR		CAN_TXCS,4
#DEFINE	ACKERR	CAN_TXCS,4
#DEFINE	TXLARB	CAN_TXCS,5
#DEFINE	TXABRT	CAN_TXCS,6
#DEFINE	TXBIF		CAN_TXCS,7

CANCS		EQU		812H
CAN_CS	EQU		812H
CAN_BUFST	EQU		812H
CAN_BUFSTAT	EQU		812H

;	CANCS bits:
#DEFINE	EN		CANCS,0
#DEFINE	RX_TXN	CANCS,1
#DEFINE	ERRIE		CANCS,5
#DEFINE	CANTXIE	CANCS,6
#DEFINE	CANRXIE	CANCS,7

CANID0	EQU		813H
CANID1	EQU		814H
CAN_ID0	EQU		813H
CAN_ID1	EQU		814H

;	CANID1 bits:
#DEFINE	EIDEN		CANID1,3
#DEFINE	SSR		CANID1,4

CANID2	EQU		815H
CANID3	EQU		816H
CAN_ID2	EQU		815H
CAN_ID3	EQU		816H

CANDCL	EQU		817H
CAN_DLC	EQU		817H

;	CANDCL bits:
#DEFINE	DCL0	CANDCL,0
#DEFINE	DCL1	CANDCL,1
#DEFINE	DCL2	CANDCL,2
#DEFINE	DCL3	CANDCL,3
#DEFINE	R0	CANDCL,4
#DEFINE	R1	CANDCL,5
#DEFINE	RTRRX	CANDCL,6

;----- Bank 9 -------------------------------------------------------------

CANDB0	EQU		910H
CANDB1	EQU		911H
CANDB2	EQU		912H
CANDB3	EQU		913H
CANDB4	EQU		914H
CANDB5	EQU		915H
CANDB6	EQU		916H
CANDB7	EQU		917H

CAN_DB0	EQU		910H
CAN_DB1	EQU		911H
CAN_DB2	EQU		912H
CAN_DB3	EQU		913H
CAN_DB4	EQU		914H
CAN_DB5	EQU		915H
CAN_DB6	EQU		916H
CAN_DB7	EQU		917H

;----- Bank 14 -------------------------------------------------------------

EECONL	EQU		0E11H
EE_CONL	EQU		0E11H

;	EECONL bits:
#DEFINE	ERDL		EECONL,0
#DEFINE	EWRL		EECONL,1
#DEFINE	EERL		EECONL,2
#DEFINE	EBEL		EECONL,3
#DEFINE	EBWL		EECONL,4
#DEFINE	EETL		EECONL,5
#DEFINE	ERRL		EECONL,6
#DEFINE	LOCKL		EECONL,7

EECONH	EQU		0E12H
EE_CONH	EQU		0E12H

;	EECONH bits:
#DEFINE	ERDH		EECONH,0
#DEFINE	EWRH		EECONH,1
#DEFINE	EERH		EECONH,2
#DEFINE	EBEH		EECONH,3
#DEFINE	EBWH		EECONH,4
#DEFINE	EETH		EECONH,5
#DEFINE	ERRH		EECONH,6
#DEFINE	LOCKH		EECONH,7

;----- Bank 15 -------------------------------------------------------------

EDLSB		EQU		0F12H
EDMSB		EQU		0F13H
ED_LSB	EQU		0F12H
ED_MSB	EQU		0F13H

EEMOD		EQU		0F14H
EE_MOD	EQU		0F14H

;	EEMOD bits:
#DEFINE	ESTBY		EEMOD,0
#DEFINE	TM2		EEMOD,1
#DEFINE	TM1		EEMOD,2
#DEFINE	AM		EEMOD,3
#DEFINE	HWS		EEMOD,4
#DEFINE	CPEN		EEMOD,5
#DEFINE	RESET		EEMOD,6
#DEFINE	STATE		EEMOD,7

EAMSB		EQU		0F15H
EALSB		EQU		0F16H

EA_MSB	EQU		0F15H
EA_LSB	EQU		0F16H

CFREG		EQU		0F17H

;	CFREG bits:
#DEFINE	FOSC0		CFREG,0
#DEFINE	FOSC1		CFREG,1
#DEFINE	WDT0		CFREG,2
#DEFINE	WDT1		CFREG,3
#DEFINE	PM0		CFREG,4
#DEFINE	BODEN		CFREG,5
#DEFINE	DBGEN		CFREG,6
#DEFINE	DBG_EN	CFREG,6

;----- Unbanked -----------------------------------------------------------

PRODL		EQU		H'0018'
PL		EQU		H'0018'    ; Backward compatibility only
PRODH		EQU		H'0019'
PH		EQU		H'0019'    ; Backward compatibility only


;==========================================================================
;
;       RAM Definition
;
;==========================================================================

        __MAXRAM        H'8FF'
        __BADRAM        H'118'-H'11F', H'218'-H'21F', H'318'-H'31F'
        __BADRAM        H'412', H'418'-H'4FF'
        __BADRAM        H'518'-H'5FF'
        __BADRAM        H'615'-H'6FF'
        __BADRAM        H'717'-H'7FF'
        __BADRAM        H'814'-H'8FF'

;==========================================================================
;
;       Configuration Bits
;
;==========================================================================

;_PMC_MODE                       EQU     H'7FAF'
;_XMC_MODE                       EQU     H'FFBF'
;_MC_MODE                        EQU     H'FFEF'
;_MP_MODE                        EQU     H'FFFF'

;_BODEN_OFF                      EQU     H'BFFF'
;_BODEN_ON                       EQU     H'FFFF'

;_WDT_NORM                       EQU     H'FFF3'
;_WDT_OFF                        EQU     H'FFF3'
;_WDT_64                         EQU     H'FFF7'
;_WDT_256                        EQU     H'FFFB'
;_WDT_1                          EQU     H'FFFF'
;_WDT_0                          EQU     H'FFFF'

;_LF_OSC                         EQU     H'FFFC'
;_RC_OSC                         EQU     H'FFFD'
;_XT_OSC                         EQU     H'FFFE'
;_EC_OSC                         EQU     H'FFFF'

        LIST
