;=====================
;		MPASM
;=====================

INDF0	EQU	000H
FSR0	EQU	001H
PCL		EQU	002H
PCLATH	EQU	003H
ALUSTA	EQU	004H

;	ALUSTA bits:
#DEFINE	C	ALUSTA,0
#DEFINE	DC	ALUSTA,1
#DEFINE	Z	ALUSTA,2
#DEFINE	OV	ALUSTA,3
#DEFINE	FS0	ALUSTA,4
#DEFINE	FS1	ALUSTA,5
#DEFINE	FS2	ALUSTA,6
#DEFINE	FS3	ALUSTA,7

T0STA		EQU	005H

;	T0STA bits:
#DEFINE	T0PS0	T0STA,1
#DEFINE	T0PS1	T0STA,2
#DEFINE	T0PS2	T0STA,3
#DEFINE	T0PS3	T0STA,4
#DEFINE	T0CS	T0STA,5
#DEFINE	T0SE	T0STA,6
#DEFINE	INTEDG	T0STA,7
#DEFINE	PS0	T0STA,1
#DEFINE	PS1	T0STA,2
#DEFINE	PS2	T0STA,3
#DEFINE	PS3	T0STA,4

CPUSTA	EQU	006H

;	CPUSTA bits:
#DEFINE	BOR	CPUSTA,0
#DEFINE	POR	CPUSTA,1
#DEFINE	PD	CPUSTA,2
#DEFINE	TO	CPUSTA,3
#DEFINE	GLINTD	CPUSTA,4
#DEFINE	STKAV	CPUSTA,5
#DEFINE	ESLP	CPUSTA,6

INTSTA	EQU	007H

;	INTSTA bits:
#DEFINE	INTE	INTSTA,0
#DEFINE	T0IE	INTSTA,1
#DEFINE	T0CKIE	INTSTA,2
#DEFINE	PEIE	INTSTA,3
#DEFINE	INTF	INTSTA,4
#DEFINE	T0IF	INTSTA,5
#DEFINE	T0CKIF	INTSTA,6
#DEFINE	PEIF	INTSTA,7

INDF1		EQU	008H
FSR1		EQU	009H
WREG		EQU	00AH
TMR0L		EQU	00BH
TMR0H		EQU	00CH
TBLPTRL	EQU	00DH
TBLPTRH	EQU	00EH
BSR		EQU	00FH

;----- Bank 0 -------------------------------------------------------------

LIN_CNTR	EQU	011H
LIN1_CNTR	EQU	011H

;	LIN_CNTR bits:
#DEFINE	LINEN			LIN1_CNTR,0
#DEFINE	LIN1_EN			LIN1_CNTR,0
#DEFINE	LIN1_ERR		LIN1_CNTR,1
#DEFINE	LIN1_SYNCH		LIN1_CNTR,2
#DEFINE	LIN1_BRK		LIN1_CNTR,3
#DEFINE	LIN1_BRKCNT0	LIN1_CNTR,4
#DEFINE	LIN1_BRKCNT1	LIN1_CNTR,5
#DEFINE	LIN1_BRKCNT2	LIN1_CNTR,6
#DEFINE	LIN1_BRKCNT3	LIN1_CNTR,7

LIN1_BRG	EQU	012H
RCSTA1	EQU	013H

;	RCSTA1 bits:
#DEFINE	RX9D1	RCSTA1,0
#DEFINE	OERR1	RCSTA1,1
#DEFINE	FERR1	RCSTA1,2
#DEFINE	CREN1	RCSTA1,4
#DEFINE	SREN1	RCSTA1,5
#DEFINE	RX91	RCSTA1,6
#DEFINE	SPEN1	RCSTA1,7

RCREG1		EQU	014H
TXSTA1		EQU	015H

;	TXSTA1 bits:
#DEFINE	TX9D1	TXSTA1,0
#DEFINE	TRMT1	TXSTA1,1
#DEFINE	SYNC1	TXSTA1,4
#DEFINE	TXEN1	TXSTA1,5
#DEFINE	TX91	TXSTA1,6
#DEFINE	CSRC1	TXSTA1,7

TXREG1	EQU	016H
SPBRG1	EQU	017H

;----- Bank 1 -------------------------------------------------------------

DDRA		EQU	110H

;	DDRA bits:
#DEFINE	DDRA7 DDRA,7
#DEFINE	DDRA6 DDRA,6
#DEFINE	DDRA5 DDRA,5
#DEFINE	DDRA4 DDRA,4
#DEFINE	DDRA3 DDRA,3
#DEFINE	DDRA2 DDRA,2
#DEFINE	DDRA1 DDRA,1
#DEFINE	DDRA0 DDRA,0

PORTA		EQU	111H

;	PORTA bits:
#DEFINE	PORTA7 PORTA,7
#DEFINE	PORTA6 PORTA,6
#DEFINE	PORTA5 PORTA,5
#DEFINE	PORTA4 PORTA,4
#DEFINE	PORTA3 PORTA,3
#DEFINE	PORTA2 PORTA,2
#DEFINE	PORTA1 PORTA,1
#DEFINE	PORTA0 PORTA,0

DDRC		EQU	112H

;	DDRC bits:
#DEFINE	DDRC7 DDRC,7
#DEFINE	DDRC6 DDRC,6
#DEFINE	DDRC5 DDRC,5
#DEFINE	DDRC4 DDRC,4
#DEFINE	DDRC3 DDRC,3
#DEFINE	DDRC2 DDRC,2
#DEFINE	DDRC1 DDRC,1
#DEFINE	DDRC0 DDRC,0

PORTC		EQU	113H

;	PORTC bits:
#DEFINE	PORTC7 PORTC,7
#DEFINE	PORTC6 PORTC,6
#DEFINE	PORTC5 PORTC,5
#DEFINE	PORTC4 PORTC,4
#DEFINE	PORTC3 PORTC,3
#DEFINE	PORTC2 PORTC,2
#DEFINE	PORTC1 PORTC,1
#DEFINE	PORTC0 PORTC,0

DDRD		EQU	114H

;	DDRD bits:
#DEFINE	DDRD7 DDRD,7
#DEFINE	DDRD6 DDRD,6
#DEFINE	DDRD5 DDRD,5
#DEFINE	DDRD4 DDRD,4
#DEFINE	DDRD3 DDRD,3
#DEFINE	DDRD2 DDRD,2
#DEFINE	DDRD1 DDRD,1
#DEFINE	DDRD0 DDRD,0

PORTD		EQU	115H

;	PORTD bits:
#DEFINE	PORTD7 PORTD,7
#DEFINE	PORTD6 PORTD,6
#DEFINE	PORTD5 PORTD,5
#DEFINE	PORTD4 PORTD,4
#DEFINE	PORTD3 PORTD,3
#DEFINE	PORTD2 PORTD,2
#DEFINE	PORTD1 PORTD,1
#DEFINE	PORTD0 PORTD,0
;----- Bank 2 -------------------------------------------------------------

TMR1		EQU	210H
TMR1L		EQU	210H

TMR1H		EQU	211H

TMR2		EQU	212H
TMR2L		EQU	212H

TMR2H		EQU	213H

PR1			EQU	214H
PR1L		EQU	214H

PR1H		EQU	215H

PR2			EQU	216H
PR2L		EQU	216H
CA1L		EQU	216H
PR2H		EQU	217H
CA1H		EQU	217H

;----- Bank 3 -------------------------------------------------------------

PW1DCL	EQU	310H

;	PW1DCL bits:
#DEFINE	PW1_DC1	PW1DCL,7
#DEFINE	PW1_DC0	PW1DCL,6

PW2DCL	EQU	311H

;	PW2DCL bits:
#DEFINE	PW2_DC1	PW2DCL,7
#DEFINE	PW2_DC0	PW2DCL,6

PW1DCH	EQU	312H

;	PW1DCH bits:
#DEFINE	PW1_DC9	PW1DCH,7
#DEFINE	PW1_DC8	PW1DCH,6
#DEFINE	PW1_DC7	PW1DCH,5
#DEFINE	PW1_DC6	PW1DCH,4
#DEFINE	PW1_DC5	PW1DCH,3
#DEFINE	PW1_DC4	PW1DCH,2
#DEFINE	PW1_DC3	PW1DCH,1
#DEFINE	PW1_DC2	PW1DCH,0

PW2DCH	EQU	313H

;	PW2DCH bits:
#DEFINE	PW2_DC9	PW2DCH,7
#DEFINE	PW2_DC8	PW2DCH,6
#DEFINE	PW2_DC7	PW2DCH,5
#DEFINE	PW2_DC6	PW2DCH,4
#DEFINE	PW2_DC5	PW2DCH,3
#DEFINE	PW2_DC4	PW2DCH,2
#DEFINE	PW2_DC3	PW2DCH,1
#DEFINE	PW2_DC2	PW2DCH,0

CA2L		EQU	314H
CA2H		EQU	315H

TCON1		EQU	316H

;	TCON1 bits:
#DEFINE	TMR1CS	TCON1,0
#DEFINE	TMR2CS	TCON1,2
#DEFINE	CA1ED0	TCON1,4
#DEFINE	CA1ED1	TCON1,5
#DEFINE	CA2ED0	TCON1,6
#DEFINE	CA2ED1	TCON1,7

TCON2		EQU	317H

;	TCON2 bits:
#DEFINE	TMR1ON	TCON2,0
#DEFINE	TMR2ON	TCON2,2
#DEFINE	CA1_PR2	TCON2,3
#DEFINE	PWM1ON	TCON2,4
#DEFINE	PWM2ON	TCON2,5
#DEFINE	CA1OVF	TCON2,6
#DEFINE	CA2OVF	TCON2,7

;----- Bank 4 -------------------------------------------------------------

PW1DCHH	EQU	410H

;	PW1DCHH bits:
#DEFINE	PW1_DC17	PW1DCHH,7
#DEFINE	PW1_DC16	PW1DCHH,6
#DEFINE	PW1_DC15	PW1DCHH,5
#DEFINE	PW1_DC14	PW1DCHH,4
#DEFINE	PW1_DC13	PW1DCHH,3
#DEFINE	PW1_DC12	PW1DCHH,2
#DEFINE	PW1_DC11	PW1DCHH,1
#DEFINE	PW1_DC10	PW1DCHH,0

PW2DCHH	EQU	411H

;	PW2DCHH bits:
#DEFINE	PW2_DC17	PW2DCHH,7
#DEFINE	PW2_DC16	PW2DCHH,6
#DEFINE	PW2_DC15	PW2DCHH,5
#DEFINE	PW2_DC14	PW2DCHH,4
#DEFINE	PW2_DC13	PW2DCHH,3
#DEFINE	PW2_DC12	PW2DCHH,2
#DEFINE	PW2_DC11	PW2DCHH,1
#DEFINE	PW2_DC10	PW2DCHH,0

DAC_CONT	EQU	412H

;	DAC_CONT bits:
#DEFINE	DACFM		DAC_CONT,0
#DEFINE	MREF0		DAC_CONT,1
#DEFINE	ENOUT0		DAC_CONT,2
#DEFINE	DACON0		DAC_CONT,3
#DEFINE	MREF1		DAC_CONT,4
#DEFINE	ENOUT1		DAC_CONT,5
#DEFINE	DACON1		DAC_CONT,6
#DEFINE	SYNC_A		DAC_CONT,7

DAC1L	EQU	413H
DAC1H	EQU	414H
DAC2L	EQU	415H
DAC2H	EQU	416H

COMPARE	EQU	417H

;	COMPARE bits:
#DEFINE	COMP_ON		COMPARE,0
#DEFINE	CONTR0		COMPARE,1
#DEFINE	CONTR1		COMPARE,2
#DEFINE	PH_NL		COMPARE,3
#DEFINE	E_L			COMPARE,4
#DEFINE	C_IF		COMPARE,5
#DEFINE	STAGE		COMPARE,6
#DEFINE	RESULT		COMPARE,7

;----- Bank 5 -------------------------------------------------------------

PIR1	EQU	510H

;	PIR1 bits:
#DEFINE	RC1IF		PIR1,0
#DEFINE	TX1IF		PIR1,1
#DEFINE	CAP1IF		PIR1,2
#DEFINE	CAP2IF		PIR1,3
#DEFINE	TMR1IF		PIR1,4
#DEFINE	TMR2IF		PIR1,5
#DEFINE	ADCIF		PIR1,6
#DEFINE	EEPROMIF	PIR1,7
#DEFINE	T1IF		PIR1,4
#DEFINE	T2IF		PIR1,5

PIE1	EQU	511H

;	PIE1 bits:
#DEFINE	RC1IE		PIE1,0
#DEFINE	TX1IE		PIE1,1
#DEFINE	CAP1IE		PIE1,2
#DEFINE	CAP2IE		PIE1,3
#DEFINE	TMR1IE		PIE1,4
#DEFINE	TMR2IE		PIE1,5
#DEFINE	ADCIE		PIE1,6
#DEFINE	EEPROMIE	PIE1,7
#DEFINE	T1IE		PIE1,4
#DEFINE	T2IE		PIE1,5

PIR2	EQU	512H

;	PIR2 bits:
#DEFINE	RC2IF		PIR2,0
#DEFINE	TX2IF		PIR2,1
#DEFINE	COMPIF	PIR2,2

PIE2	EQU	513H

;	PIE2 bits:
#DEFINE	RC2IE		PIE2,0
#DEFINE	TX2IE		PIE2,1
#DEFINE	COMPIE		PIE2,2

EE_CONT	EQU	514H

;	EE_CONT bits:
#DEFINE	EEBRG0		EE_CONT,0
#DEFINE	EEBRG1		EE_CONT,1
#DEFINE	EEBRG2		EE_CONT,2
#DEFINE	VEE1		EE_CONT,3
#DEFINE	VEE2		EE_CONT,4
#DEFINE	CPTEST		EE_CONT,5
#DEFINE	EETEST		EE_CONT,6
#DEFINE	TEST_P		EE_CONT,7

EE_MODE	EQU	515H

;	EE_MODE	 bits:
#DEFINE	EE_MODE0	EE_MODE,0
#DEFINE	EE_MODE1	EE_MODE,1
#DEFINE	EE_MODE2	EE_MODE,2
#DEFINE	EE_BUSY 	EE_MODE,4
#DEFINE	IE_BUSY		EE_MODE,5
#DEFINE	EN			EE_MODE,7

#DEFINE	MODE0		EE_MODE,0
#DEFINE	MODE1		EE_MODE,1
#DEFINE	MODE2		EE_MODE,2
#DEFINE	BUSY 		EE_MODE,4
#DEFINE	IEBUSY		EE_MODE,5
#DEFINE	EN_EE		EE_MODE,7

EE_DATA	EQU	516H
EE_ADR	EQU	517H

;----- Bank 6 -------------------------------------------------------------

DBH		EQU	610H
DBL		EQU	611H
EE_DIV	EQU	613H
EEDIV	EQU	613H

ADCON0	EQU	614H

;	ADCON0 bits:
#DEFINE	ADON		ADCON0,0
#DEFINE	GO_DONE		ADCON0,2
#DEFINE	CHS0		ADCON0,4
#DEFINE	CHS1		ADCON0,5
#DEFINE	CHS2		ADCON0,6

ADCON1	EQU	615H

;	ADCON1 bits:
#DEFINE	PCFG0		ADCON1,0
#DEFINE	PCFG1		ADCON1,1
#DEFINE	PCFG2		ADCON1,2
#DEFINE	PCFG3		ADCON1,3
#DEFINE	ADFM		ADCON1,5
#DEFINE	ADCS0		ADCON1,6
#DEFINE	ADCS1		ADCON1,7

ADRESL	EQU	616H
ADRESH	EQU	617H
;----- Bank 7 ------------------------------------------------------------

LIN2_CNTR	EQU	711H

;	LIN2_CNTR bits:
#DEFINE	LINEN2		LIN2_CNTR,0
#DEFINE	ERR2		LIN2_CNTR,1
#DEFINE	SYNCH2		LIN2_CNTR,2
#DEFINE	BRK2		LIN2_CNTR,3
#DEFINE	BRK2CNT0	LIN2_CNTR,4
#DEFINE	BRK2CNT1	LIN2_CNTR,5
#DEFINE	BRK2CNT2	LIN2_CNTR,6
#DEFINE	BRK2CNT3	LIN2_CNTR,7

#DEFINE	LIN2_EN	LIN2_CNTR,0
#DEFINE	LIN2_ERR		LIN2_CNTR,1
#DEFINE	LIN2_SYNCH		LIN2_CNTR,2
#DEFINE	LIN2_BRK		LIN2_CNTR,3
#DEFINE	LIN2_BRKCNT0	LIN2_CNTR,4
#DEFINE	LIN2_BRKCNT1	LIN2_CNTR,5
#DEFINE	LIN2_BRKCNT2	LIN2_CNTR,6
#DEFINE	LIN2_BRKCNT3	LIN2_CNTR,7

LIN2_BRG	EQU	712H

RCSTA2	EQU	713H

;	RCSTA2 bits:
#DEFINE	RX9D2	RCSTA2,0
#DEFINE	OERR2	RCSTA2,1
#DEFINE	FERR2	RCSTA2,2
#DEFINE	CREN2	RCSTA2,4
#DEFINE	SREN2	RCSTA2,5
#DEFINE	RX92	RCSTA2,6
#DEFINE	SPEN2	RCSTA2,7

RCREG2	EQU	714H
TXSTA2	EQU	715H

;	TXSTA2 bits:
#DEFINE	TX9D2	TXSTA2,0
#DEFINE	TRMT2	TXSTA2,1
#DEFINE	SYNC2	TXSTA2,4
#DEFINE	TXEN2	TXSTA2,5
#DEFINE	TX92	TXSTA2,6
#DEFINE	CSRC2	TXSTA2,7

TXREG2	EQU	716H
SPBRG2	EQU	717H

;----- Bank 14 -------------------------------------------------------------

EECONL	EQU		0E11H

;	EECONL bits:
#DEFINE	ERDL		EECONL,0
#DEFINE	EWRL		EECONL,1
#DEFINE	EERL		EECONL,2
#DEFINE	EBEL		EECONL,3
#DEFINE	EBWL		EECONL,4
#DEFINE	EETL		EECONL,5
#DEFINE	ERRL		EECONL,6
#DEFINE	LOCKL		EECONL,7

EECONH	EQU		0E12H

;	EECONH bits:
#DEFINE	ERDH		EECONH,0
#DEFINE	EWRH		EECONH,1
#DEFINE	EERH		EECONH,2
#DEFINE	EBEH		EECONH,3
#DEFINE	EBWH		EECONH,4
#DEFINE	EETH		EECONH,5
#DEFINE	ERRH		EECONH,6
#DEFINE	LOCKH		EECONH,7

;----- Bank 15 -------------------------------------------------------------

EDLSB	EQU		0F12H
EDMSB	EQU		0F13H

EEMOD	EQU		0F14H

;	EEMOD bits:
#DEFINE	ESTBY		EEMOD,0
#DEFINE	TM1			EEMOD,1
#DEFINE	TM2			EEMOD,2
#DEFINE	AM			EEMOD,3
#DEFINE	HWS			EEMOD,4
#DEFINE	CPEN		EEMOD,5
#DEFINE	RESET		EEMOD,6
#DEFINE	STATE		EEMOD,7

EAMSB	EQU		0F15H
EALSB	EQU		0F16H

;	EAMSB bits:
#DEFINE	CPRDY		EAMSB,7

CFREG	EQU		0F17H

;	CFREG bits:
#DEFINE	FOSC0		CFREG,0
#DEFINE	FOSC1		CFREG,1
#DEFINE	WDT0		CFREG,2
#DEFINE	WDT1		CFREG,3
#DEFINE	PM0			CFREG,4
#DEFINE	BODEN		CFREG,5
#DEFINE	DBGEN		CFREG,6

;----- Unbanked -----------------------------------------------------------

PRODL		EQU	018H
PRODH		EQU	019H

;--------------------------------------------------------------------------

W		EQU	000H
F		EQU	001H

Bank0		EQU	000H
Bank1		EQU	001H
Bank2		EQU	002H
Bank3		EQU	003H
Bank4		EQU	004H
Bank5		EQU	005H
Bank6		EQU	006H
Bank7		EQU	007H
Bank8		EQU	008H
Bank14		EQU	00EH
Bank15		EQU	00FH

BANK0		EQU	000H
BANK1		EQU	001H
BANK2		EQU	002H
BANK3		EQU	003H
BANK4		EQU	004H
BANK5		EQU	005H
BANK6		EQU	006H
BANK7		EQU	007H
BANK8		EQU	008H
BANK14		EQU	00EH
BANK15		EQU	00FH
; ==========================================================================
