;==========================================================================
;		 MPASM (Microchip)
;==========================================================================

INDF0		EQU	000H
FSR0		EQU	001H
PCL		EQU	002H
PCLATH	EQU	003H
ALUSTA	EQU	004H

;	ALUSTA bits:
#DEFINE	C		ALUSTA,0
#DEFINE	DC		ALUSTA,1
#DEFINE	Z		ALUSTA,2
#DEFINE	OV		ALUSTA,3
#DEFINE	FS0		ALUSTA,4
#DEFINE	FS1		ALUSTA,5
#DEFINE	FS2		ALUSTA,6
#DEFINE	FS3		ALUSTA,7

T0STA		EQU	005H

;	T0STA bits:
#DEFINE	T0PS0		T0STA,1
#DEFINE	T0PS1		T0STA,2
#DEFINE	T0PS2		T0STA,3
#DEFINE	T0PS3		T0STA,4
#DEFINE	T0CS		T0STA,5
#DEFINE	T0SE		T0STA,6
#DEFINE	INTEDG	T0STA,7

CPUSTA	EQU	006H

;	CPUSTA bits:
#DEFINE	BOR		CPUSTA,0
#DEFINE	POR		CPUSTA,1
#DEFINE	NOT_PD	CPUSTA,2
#DEFINE	NOT_TO	CPUSTA,3
#DEFINE	PD		CPUSTA,2
#DEFINE	TO		CPUSTA,3
#DEFINE	GLINTD	CPUSTA,4
#DEFINE	STKAV		CPUSTA,5

INTSTA	EQU	007H

;	INTSTA bits:
#DEFINE	INTE		INTSTA,0
#DEFINE	T0IE		INTSTA,1
#DEFINE	T0CKIE	INTSTA,2
#DEFINE	PEIE		INTSTA,3
#DEFINE	INTF		INTSTA,4
#DEFINE	T0IF		INTSTA,5
#DEFINE	T0CKIF	INTSTA,6
#DEFINE	PEIF		INTSTA,7

INDF1		EQU	008H
FSR1		EQU	009H
WREG		EQU	00AH
TMR0L		EQU	00BH
TMR0H		EQU	00CH
TBLPTRL	EQU	00DH
TBLPTRH	EQU	00EH
BSR		EQU	00FH

;----- Bank 0 -------------------------------------------------------------

LIN_CNTR	EQU	011H
LINCNTR	EQU	011H

;	LINCNTR bits:
#DEFINE	LINEN		LINCNTR,0
#DEFINE	ERR		LINCNTR,1
#DEFINE	SYNCH		LINCNTR,2
#DEFINE	BRK		LINCNTR,3
#DEFINE	BRKCNT0	LINCNTR,4
#DEFINE	BRKCNT1	LINCNTR,5
#DEFINE	BRKCNT2	LINCNTR,6
#DEFINE	BRKCNT3	LINCNTR,7

LIN_BRG	EQU	012H
LINBRG	EQU	012H

RCSTA1	EQU	013H
RCSTA		EQU	013H

;	RCSTA bits:
#DEFINE	RX9D1		RCSTA,0
#DEFINE	OERR1		RCSTA,1
#DEFINE	FERR1		RCSTA,2
#DEFINE	CREN1		RCSTA,4
#DEFINE	SREN1		RCSTA,5
#DEFINE	RX91		RCSTA,6
#DEFINE	SPEN1		RCSTA,7

#DEFINE	RX9D		RCSTA,0
#DEFINE	OERR		RCSTA,1
#DEFINE	FERR		RCSTA,2
#DEFINE	CREN		RCSTA,4
#DEFINE	SREN		RCSTA,5
#DEFINE	RX9		RCSTA,6
#DEFINE	SPEN		RCSTA,7

RCREG1	EQU	014H
RCREG		EQU	014H

TXSTA1	EQU	015H
TXSTA		EQU	015H

;	TXSTA bits:
#DEFINE	TX9D1		TXSTA,0
#DEFINE	TRMT1		TXSTA,1
#DEFINE	SYNC1		TXSTA,4
#DEFINE	TXEN1		TXSTA,5
#DEFINE	TX91		TXSTA,6
#DEFINE	CSRC1		TXSTA,7

#DEFINE	TX9D		TXSTA,0
#DEFINE	TRMT		TXSTA,1
#DEFINE	SYNC		TXSTA,4
#DEFINE	TXEN		TXSTA,5
#DEFINE	TX9		TXSTA,6
#DEFINE	CSRC		TXSTA,7

TXREG1	EQU	016H
TXREG		EQU	016H
SPBRG1	EQU	017H
SPBRG		EQU	017H

;----- Bank 1 -------------------------------------------------------------

DDRA		EQU	110H
PORTA		EQU	111H

;	PORTA bits:
#DEFINE	PORTA0		PORTA,0
#DEFINE	PORTA1		PORTA,1
#DEFINE	PORTA2		PORTA,2
#DEFINE	PORTA3		PORTA,3
#DEFINE	PORTA4		PORTA,4
#DEFINE	PORTA5		PORTA,5
#DEFINE	PORTA6		PORTA,6
#DEFINE	PORTA7		PORTA,7

;----- Bank 5 -------------------------------------------------------------

PIR1		EQU	510H

;	PIR1 bits:
#DEFINE	RC1IF		PIR1,0
#DEFINE	TX1IF		PIR1,1
#DEFINE	EEPROMIF	PIR1,2
#DEFINE	DBUGIF	PIR1,3

#DEFINE	RCIF		PIR1,0
#DEFINE	TXIF		PIR1,1

PIE1		EQU	511H

;	PIE1 bits:
#DEFINE	RC1IE		PIE1,0
#DEFINE	TX1IE		PIE1,1
#DEFINE	EEPROMIE	PIE1,2

#DEFINE	RCIE		PIE1,0
#DEFINE	TXIE		PIE1,1

EE_CONT	EQU	514H

;	EE_CONT bits:
#DEFINE	BRG0		EE_CONT,0
#DEFINE	BRG1		EE_CONT,1
#DEFINE	BRG2		EE_CONT,2
#DEFINE	VEE1		EE_CONT,3
#DEFINE	VEE2		EE_CONT,4
#DEFINE	CP_TEST	EE_CONT,5
#DEFINE	EE_TEST	EE_CONT,6
#DEFINE	TEST_p	EE_CONT,7

#DEFINE	CPTEST	EE_CONT,5
#DEFINE	EETEST	EE_CONT,6
#DEFINE	TEST_P	EE_CONT,7

EE_MODE	EQU	515H

;	EE_MODE	 bits:
#DEFINE	EE_MODE0 	EE_MODE,0
#DEFINE	EE_MODE1 	EE_MODE,1
#DEFINE	EE_MODE2 	EE_MODE,2
#DEFINE	EE_BUSY  	EE_MODE,4
#DEFINE	IE_BUSY	EE_MODE,5
#DEFINE	EE_EN	 	EE_MODE,7

#DEFINE	MODE0 	EE_MODE,0
#DEFINE	MODE1 	EE_MODE,1
#DEFINE	MODE2 	EE_MODE,2
#DEFINE	BUSY  	EE_MODE,4
#DEFINE	IEBUSY	EE_MODE,5
#DEFINE	EN_EE	 	EE_MODE,7

EE_DATA	EQU	516H
EE_ADR	EQU	517H

;----- Bank 6 -------------------------------------------------------------

DBH		EQU	610H
DBL		EQU	611H
EE_DIV	EQU	613H
EEDIV		EQU	613H

;----- Bank 14 ------------------------------------------------------------

EE_CON	EQU	0E11H
EECON		EQU	0E11H

;	EE_CON bits:
#DEFINE	ERD		EE_CON,0
#DEFINE	EWR		EE_CON,1
#DEFINE	EER		EE_CON,2
#DEFINE	EBE		EE_CON,3
#DEFINE	EBW		EE_CON,4
#DEFINE	EET		EE_CON,5
#DEFINE	ERROR		EE_CON,6
#DEFINE	LOCK		EE_CON,7

;----- Bank 15 ------------------------------------------------------------

ED_LSB	EQU	0F12H
EDLSB		EQU	0F12H
ED_MSB	EQU	0F13H
EDMSB		EQU	0F13H

EE_MOD	EQU	0F14H
EEMOD		EQU	0F14H

;	EEMOD bits:
#DEFINE	ESTBY	EEMOD,0
#DEFINE	TM1	EEMOD,1
#DEFINE	TM2	EEMOD,2
#DEFINE	AM	EEMOD,3
#DEFINE	HWS	EEMOD,4
#DEFINE	CPEN	EEMOD,5
#DEFINE	RESET	EEMOD,6
#DEFINE	STATE	EEMOD,7

EA_MSB	EQU	0F15H
EAMSB		EQU	0F15H

;	EAMSB bits:
#DEFINE	CPRDY	EAMSB,7
#DEFINE	EA10	EAMSB,2
#DEFINE	EA9	EAMSB,1
#DEFINE	EA8	EAMSB,0

EA_LSB	EQU	0F16H
EALSB		EQU	0F16H

;	EALSB bits:
#DEFINE	EA0	EALSB,0
#DEFINE	EA1	EALSB,1
#DEFINE	EA2	EALSB,2
#DEFINE	EA3	EALSB,3
#DEFINE	EA4	EALSB,4
#DEFINE	EA5	EALSB,5
#DEFINE	EA6	EALSB,6
#DEFINE	EA7	EALSB,7

CFREG		EQU	0F17H

;----- Unbanked -----------------------------------------------------------

PRODL		EQU	018H
PRODH		EQU	019H

;--------------------------------------------------------------------------

W		EQU	000H
F		EQU	001H

Bank0		EQU	000H
Bank1		EQU	001H
Bank5		EQU	005H
Bank6		EQU	006H
Bank14	EQU	00EH
Bank15	EQU	00FH

BANK0		EQU	000H
BANK1		EQU	001H
BANK5		EQU	005H
BANK6		EQU	006H
BANK14	EQU	00EH
BANK15	EQU	00FH
; ==========================================================================
